var Pe = Object.defineProperty;
var Re = (o, t, e) => t in o ? Pe(o, t, { enumerable: !0, configurable: !0, writable: !0, value: e }) : o[t] = e;
var yt = (o, t, e) => (Re(o, typeof t != "symbol" ? t + "" : t, e), e);
import { ViewPlugin as Oe, EditorView as ge, Decoration as ft, WidgetType as qe, Direction as Mt, logException as Be } from "@codemirror/view";
import { StateField as xe, RangeSetBuilder as ze, Facet as Se, EditorState as Tt, StateEffect as Ve } from "@codemirror/state";
const be = 1024;
let He = 0;
class Pt {
  constructor(t, e) {
    this.from = t, this.to = e;
  }
}
class x {
  /**
  Create a new node prop type.
  */
  constructor(t = {}) {
    this.id = He++, this.perNode = !!t.perNode, this.deserialize = t.deserialize || (() => {
      throw new Error("This node type doesn't define a deserialize function");
    });
  }
  /**
  This is meant to be used with
  [`NodeSet.extend`](#common.NodeSet.extend) or
  [`LRParser.configure`](#lr.ParserConfig.props) to compute
  prop values for each node type in the set. Takes a [match
  object](#common.NodeType^match) or function that returns undefined
  if the node type doesn't get this prop, and the prop's value if
  it does.
  */
  add(t) {
    if (this.perNode)
      throw new RangeError("Can't add per-node props to node types");
    return typeof t != "function" && (t = P.match(t)), (e) => {
      let s = t(e);
      return s === void 0 ? null : [this, s];
    };
  }
}
x.closedBy = new x({ deserialize: (o) => o.split(" ") });
x.openedBy = new x({ deserialize: (o) => o.split(" ") });
x.group = new x({ deserialize: (o) => o.split(" ") });
x.isolate = new x({ deserialize: (o) => {
  if (o && o != "rtl" && o != "ltr" && o != "auto")
    throw new RangeError("Invalid value for isolate: " + o);
  return o || "auto";
} });
x.contextHash = new x({ perNode: !0 });
x.lookAhead = new x({ perNode: !0 });
x.mounted = new x({ perNode: !0 });
class bt {
  constructor(t, e, s) {
    this.tree = t, this.overlay = e, this.parser = s;
  }
  /**
  @internal
  */
  static get(t) {
    return t && t.props && t.props[x.mounted.id];
  }
}
const De = /* @__PURE__ */ Object.create(null);
class P {
  /**
  @internal
  */
  constructor(t, e, s, $ = 0) {
    this.name = t, this.props = e, this.id = s, this.flags = $;
  }
  /**
  Define a node type.
  */
  static define(t) {
    let e = t.props && t.props.length ? /* @__PURE__ */ Object.create(null) : De, s = (t.top ? 1 : 0) | (t.skipped ? 2 : 0) | (t.error ? 4 : 0) | (t.name == null ? 8 : 0), $ = new P(t.name || "", e, t.id, s);
    if (t.props) {
      for (let r of t.props)
        if (Array.isArray(r) || (r = r($)), r) {
          if (r[0].perNode)
            throw new RangeError("Can't store a per-node prop on a node type");
          e[r[0].id] = r[1];
        }
    }
    return $;
  }
  /**
  Retrieves a node prop for this type. Will return `undefined` if
  the prop isn't present on this node.
  */
  prop(t) {
    return this.props[t.id];
  }
  /**
  True when this is the top node of a grammar.
  */
  get isTop() {
    return (this.flags & 1) > 0;
  }
  /**
  True when this node is produced by a skip rule.
  */
  get isSkipped() {
    return (this.flags & 2) > 0;
  }
  /**
  Indicates whether this is an error node.
  */
  get isError() {
    return (this.flags & 4) > 0;
  }
  /**
  When true, this node type doesn't correspond to a user-declared
  named node, for example because it is used to cache repetition.
  */
  get isAnonymous() {
    return (this.flags & 8) > 0;
  }
  /**
  Returns true when this node's name or one of its
  [groups](#common.NodeProp^group) matches the given string.
  */
  is(t) {
    if (typeof t == "string") {
      if (this.name == t)
        return !0;
      let e = this.prop(x.group);
      return e ? e.indexOf(t) > -1 : !1;
    }
    return this.id == t;
  }
  /**
  Create a function from node types to arbitrary values by
  specifying an object whose property names are node or
  [group](#common.NodeProp^group) names. Often useful with
  [`NodeProp.add`](#common.NodeProp.add). You can put multiple
  names, separated by spaces, in a single property name to map
  multiple node names to a single value.
  */
  static match(t) {
    let e = /* @__PURE__ */ Object.create(null);
    for (let s in t)
      for (let $ of s.split(" "))
        e[$] = t[s];
    return (s) => {
      for (let $ = s.prop(x.group), r = -1; r < ($ ? $.length : 0); r++) {
        let i = e[r < 0 ? s.name : $[r]];
        if (i)
          return i;
      }
    };
  }
}
P.none = new P(
  "",
  /* @__PURE__ */ Object.create(null),
  0,
  8
  /* NodeFlag.Anonymous */
);
class At {
  /**
  Create a set with the given types. The `id` property of each
  type should correspond to its position within the array.
  */
  constructor(t) {
    this.types = t;
    for (let e = 0; e < t.length; e++)
      if (t[e].id != e)
        throw new RangeError("Node type ids should correspond to array positions when creating a node set");
  }
  /**
  Create a copy of this set with some node properties added. The
  arguments to this method can be created with
  [`NodeProp.add`](#common.NodeProp.add).
  */
  extend(...t) {
    let e = [];
    for (let s of this.types) {
      let $ = null;
      for (let r of t) {
        let i = r(s);
        i && ($ || ($ = Object.assign({}, s.props)), $[i[0].id] = i[1]);
      }
      e.push($ ? new P(s.name, $, s.id, s.flags) : s);
    }
    return new At(e);
  }
}
const dt = /* @__PURE__ */ new WeakMap(), te = /* @__PURE__ */ new WeakMap();
var F;
(function(o) {
  o[o.ExcludeBuffers = 1] = "ExcludeBuffers", o[o.IncludeAnonymous = 2] = "IncludeAnonymous", o[o.IgnoreMounts = 4] = "IgnoreMounts", o[o.IgnoreOverlays = 8] = "IgnoreOverlays";
})(F || (F = {}));
class X {
  /**
  Construct a new tree. See also [`Tree.build`](#common.Tree^build).
  */
  constructor(t, e, s, $, r) {
    if (this.type = t, this.children = e, this.positions = s, this.length = $, this.props = null, r && r.length) {
      this.props = /* @__PURE__ */ Object.create(null);
      for (let [i, n] of r)
        this.props[typeof i == "number" ? i : i.id] = n;
    }
  }
  /**
  @internal
  */
  toString() {
    let t = bt.get(this);
    if (t && !t.overlay)
      return t.tree.toString();
    let e = "";
    for (let s of this.children) {
      let $ = s.toString();
      $ && (e && (e += ","), e += $);
    }
    return this.type.name ? (/\W/.test(this.type.name) && !this.type.isError ? JSON.stringify(this.type.name) : this.type.name) + (e.length ? "(" + e + ")" : "") : e;
  }
  /**
  Get a [tree cursor](#common.TreeCursor) positioned at the top of
  the tree. Mode can be used to [control](#common.IterMode) which
  nodes the cursor visits.
  */
  cursor(t = 0) {
    return new vt(this.topNode, t);
  }
  /**
  Get a [tree cursor](#common.TreeCursor) pointing into this tree
  at the given position and side (see
  [`moveTo`](#common.TreeCursor.moveTo).
  */
  cursorAt(t, e = 0, s = 0) {
    let $ = dt.get(this) || this.topNode, r = new vt($);
    return r.moveTo(t, e), dt.set(this, r._tree), r;
  }
  /**
  Get a [syntax node](#common.SyntaxNode) object for the top of the
  tree.
  */
  get topNode() {
    return new z(this, 0, 0, null);
  }
  /**
  Get the [syntax node](#common.SyntaxNode) at the given position.
  If `side` is -1, this will move into nodes that end at the
  position. If 1, it'll move into nodes that start at the
  position. With 0, it'll only enter nodes that cover the position
  from both sides.
  
  Note that this will not enter
  [overlays](#common.MountedTree.overlay), and you often want
  [`resolveInner`](#common.Tree.resolveInner) instead.
  */
  resolve(t, e = 0) {
    let s = pt(dt.get(this) || this.topNode, t, e, !1);
    return dt.set(this, s), s;
  }
  /**
  Like [`resolve`](#common.Tree.resolve), but will enter
  [overlaid](#common.MountedTree.overlay) nodes, producing a syntax node
  pointing into the innermost overlaid tree at the given position
  (with parent links going through all parent structure, including
  the host trees).
  */
  resolveInner(t, e = 0) {
    let s = pt(te.get(this) || this.topNode, t, e, !0);
    return te.set(this, s), s;
  }
  /**
  In some situations, it can be useful to iterate through all
  nodes around a position, including those in overlays that don't
  directly cover the position. This method gives you an iterator
  that will produce all nodes, from small to big, around the given
  position.
  */
  resolveStack(t, e = 0) {
    return Ke(this, t, e);
  }
  /**
  Iterate over the tree and its children, calling `enter` for any
  node that touches the `from`/`to` region (if given) before
  running over such a node's children, and `leave` (if given) when
  leaving the node. When `enter` returns `false`, that node will
  not have its children iterated over (or `leave` called).
  */
  iterate(t) {
    let { enter: e, leave: s, from: $ = 0, to: r = this.length } = t, i = t.mode || 0, n = (i & F.IncludeAnonymous) > 0;
    for (let h = this.cursor(i | F.IncludeAnonymous); ; ) {
      let l = !1;
      if (h.from <= r && h.to >= $ && (!n && h.type.isAnonymous || e(h) !== !1)) {
        if (h.firstChild())
          continue;
        l = !0;
      }
      for (; l && s && (n || !h.type.isAnonymous) && s(h), !h.nextSibling(); ) {
        if (!h.parent())
          return;
        l = !0;
      }
    }
  }
  /**
  Get the value of the given [node prop](#common.NodeProp) for this
  node. Works with both per-node and per-type props.
  */
  prop(t) {
    return t.perNode ? this.props ? this.props[t.id] : void 0 : this.type.prop(t);
  }
  /**
  Returns the node's [per-node props](#common.NodeProp.perNode) in a
  format that can be passed to the [`Tree`](#common.Tree)
  constructor.
  */
  get propValues() {
    let t = [];
    if (this.props)
      for (let e in this.props)
        t.push([+e, this.props[e]]);
    return t;
  }
  /**
  Balance the direct children of this tree, producing a copy of
  which may have children grouped into subtrees with type
  [`NodeType.none`](#common.NodeType^none).
  */
  balance(t = {}) {
    return this.children.length <= 8 ? this : Gt(P.none, this.children, this.positions, 0, this.children.length, 0, this.length, (e, s, $) => new X(this.type, e, s, $, this.propValues), t.makeTree || ((e, s, $) => new X(P.none, e, s, $)));
  }
  /**
  Build a tree from a postfix-ordered buffer of node information,
  or a cursor over such a buffer.
  */
  static build(t) {
    return Ue(t);
  }
}
X.empty = new X(P.none, [], [], 0);
class Ct {
  constructor(t, e) {
    this.buffer = t, this.index = e;
  }
  get id() {
    return this.buffer[this.index - 4];
  }
  get start() {
    return this.buffer[this.index - 3];
  }
  get end() {
    return this.buffer[this.index - 2];
  }
  get size() {
    return this.buffer[this.index - 1];
  }
  get pos() {
    return this.index;
  }
  next() {
    this.index -= 4;
  }
  fork() {
    return new Ct(this.buffer, this.index);
  }
}
class Q {
  /**
  Create a tree buffer.
  */
  constructor(t, e, s) {
    this.buffer = t, this.length = e, this.set = s;
  }
  /**
  @internal
  */
  get type() {
    return P.none;
  }
  /**
  @internal
  */
  toString() {
    let t = [];
    for (let e = 0; e < this.buffer.length; )
      t.push(this.childString(e)), e = this.buffer[e + 3];
    return t.join(",");
  }
  /**
  @internal
  */
  childString(t) {
    let e = this.buffer[t], s = this.buffer[t + 3], $ = this.set.types[e], r = $.name;
    if (/\W/.test(r) && !$.isError && (r = JSON.stringify(r)), t += 4, s == t)
      return r;
    let i = [];
    for (; t < s; )
      i.push(this.childString(t)), t = this.buffer[t + 3];
    return r + "(" + i.join(",") + ")";
  }
  /**
  @internal
  */
  findChild(t, e, s, $, r) {
    let { buffer: i } = this, n = -1;
    for (let h = t; h != e && !(Je(r, $, i[h + 1], i[h + 2]) && (n = h, s > 0)); h = i[h + 3])
      ;
    return n;
  }
  /**
  @internal
  */
  slice(t, e, s) {
    let $ = this.buffer, r = new Uint16Array(e - t), i = 0;
    for (let n = t, h = 0; n < e; ) {
      r[h++] = $[n++], r[h++] = $[n++] - s;
      let l = r[h++] = $[n++] - s;
      r[h++] = $[n++] - t, i = Math.max(i, l);
    }
    return new Q(r, i, this.set);
  }
}
function Je(o, t, e, s) {
  switch (o) {
    case -2:
      return e < t;
    case -1:
      return s >= t && e < t;
    case 0:
      return e < t && s > t;
    case 1:
      return e <= t && s > t;
    case 2:
      return s > t;
    case 4:
      return !0;
  }
}
function pt(o, t, e, s) {
  for (var $; o.from == o.to || (e < 1 ? o.from >= t : o.from > t) || (e > -1 ? o.to <= t : o.to < t); ) {
    let i = !s && o instanceof z && o.index < 0 ? null : o.parent;
    if (!i)
      return o;
    o = i;
  }
  let r = s ? 0 : F.IgnoreOverlays;
  if (s)
    for (let i = o, n = i.parent; n; i = n, n = i.parent)
      i instanceof z && i.index < 0 && (($ = n.enter(t, e, r)) === null || $ === void 0 ? void 0 : $.from) != i.from && (o = n);
  for (; ; ) {
    let i = o.enter(t, e, r);
    if (!i)
      return o;
    o = i;
  }
}
class Ie {
  cursor(t = 0) {
    return new vt(this, t);
  }
  getChild(t, e = null, s = null) {
    let $ = ee(this, t, e, s);
    return $.length ? $[0] : null;
  }
  getChildren(t, e = null, s = null) {
    return ee(this, t, e, s);
  }
  resolve(t, e = 0) {
    return pt(this, t, e, !1);
  }
  resolveInner(t, e = 0) {
    return pt(this, t, e, !0);
  }
  matchContext(t) {
    return Dt(this, t);
  }
  enterUnfinishedNodesBefore(t) {
    let e = this.childBefore(t), s = this;
    for (; e; ) {
      let $ = e.lastChild;
      if (!$ || $.to != e.to)
        break;
      $.type.isError && $.from == $.to ? (s = e, e = $.prevSibling) : e = $;
    }
    return s;
  }
  get node() {
    return this;
  }
  get next() {
    return this.parent;
  }
}
class z extends Ie {
  constructor(t, e, s, $) {
    super(), this._tree = t, this.from = e, this.index = s, this._parent = $;
  }
  get type() {
    return this._tree.type;
  }
  get name() {
    return this._tree.type.name;
  }
  get to() {
    return this.from + this._tree.length;
  }
  nextChild(t, e, s, $, r = 0) {
    for (let i = this; ; ) {
      for (let { children: n, positions: h } = i._tree, l = e > 0 ? n.length : -1; t != l; t += e) {
        let f = n[t], a = h[t] + i.from;
        if (Je($, s, a, a + f.length)) {
          if (f instanceof Q) {
            if (r & F.ExcludeBuffers)
              continue;
            let p = f.findChild(0, f.buffer.length, e, s - a, $);
            if (p > -1)
              return new G(new ve(i, f, t, a), null, p);
          } else if (r & F.IncludeAnonymous || !f.type.isAnonymous || Et(f)) {
            let p;
            if (!(r & F.IgnoreMounts) && (p = bt.get(f)) && !p.overlay)
              return new z(p.tree, a, t, i);
            let c = new z(f, a, t, i);
            return r & F.IncludeAnonymous || !c.type.isAnonymous ? c : c.nextChild(e < 0 ? f.children.length - 1 : 0, e, s, $);
          }
        }
      }
      if (r & F.IncludeAnonymous || !i.type.isAnonymous || (i.index >= 0 ? t = i.index + e : t = e < 0 ? -1 : i._parent._tree.children.length, i = i._parent, !i))
        return null;
    }
  }
  get firstChild() {
    return this.nextChild(
      0,
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  get lastChild() {
    return this.nextChild(
      this._tree.children.length - 1,
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  childAfter(t) {
    return this.nextChild(
      0,
      1,
      t,
      2
      /* Side.After */
    );
  }
  childBefore(t) {
    return this.nextChild(
      this._tree.children.length - 1,
      -1,
      t,
      -2
      /* Side.Before */
    );
  }
  enter(t, e, s = 0) {
    let $;
    if (!(s & F.IgnoreOverlays) && ($ = bt.get(this._tree)) && $.overlay) {
      let r = t - this.from;
      for (let { from: i, to: n } of $.overlay)
        if ((e > 0 ? i <= r : i < r) && (e < 0 ? n >= r : n > r))
          return new z($.tree, $.overlay[0].from + this.from, -1, this);
    }
    return this.nextChild(0, 1, t, e, s);
  }
  nextSignificantParent() {
    let t = this;
    for (; t.type.isAnonymous && t._parent; )
      t = t._parent;
    return t;
  }
  get parent() {
    return this._parent ? this._parent.nextSignificantParent() : null;
  }
  get nextSibling() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(
      this.index + 1,
      1,
      0,
      4
      /* Side.DontCare */
    ) : null;
  }
  get prevSibling() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(
      this.index - 1,
      -1,
      0,
      4
      /* Side.DontCare */
    ) : null;
  }
  get tree() {
    return this._tree;
  }
  toTree() {
    return this._tree;
  }
  /**
  @internal
  */
  toString() {
    return this._tree.toString();
  }
}
function ee(o, t, e, s) {
  let $ = o.cursor(), r = [];
  if (!$.firstChild())
    return r;
  if (e != null) {
    for (; !$.type.is(e); )
      if (!$.nextSibling())
        return r;
  }
  for (; ; ) {
    if (s != null && $.type.is(s))
      return r;
    if ($.type.is(t) && r.push($.node), !$.nextSibling())
      return s == null ? r : [];
  }
}
function Dt(o, t, e = t.length - 1) {
  for (let s = o.parent; e >= 0; s = s.parent) {
    if (!s)
      return !1;
    if (!s.type.isAnonymous) {
      if (t[e] && t[e] != s.name)
        return !1;
      e--;
    }
  }
  return !0;
}
class ve {
  constructor(t, e, s, $) {
    this.parent = t, this.buffer = e, this.index = s, this.start = $;
  }
}
class G extends Ie {
  get name() {
    return this.type.name;
  }
  get from() {
    return this.context.start + this.context.buffer.buffer[this.index + 1];
  }
  get to() {
    return this.context.start + this.context.buffer.buffer[this.index + 2];
  }
  constructor(t, e, s) {
    super(), this.context = t, this._parent = e, this.index = s, this.type = t.buffer.set.types[t.buffer.buffer[s]];
  }
  child(t, e, s) {
    let { buffer: $ } = this.context, r = $.findChild(this.index + 4, $.buffer[this.index + 3], t, e - this.context.start, s);
    return r < 0 ? null : new G(this.context, this, r);
  }
  get firstChild() {
    return this.child(
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  get lastChild() {
    return this.child(
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  childAfter(t) {
    return this.child(
      1,
      t,
      2
      /* Side.After */
    );
  }
  childBefore(t) {
    return this.child(
      -1,
      t,
      -2
      /* Side.Before */
    );
  }
  enter(t, e, s = 0) {
    if (s & F.ExcludeBuffers)
      return null;
    let { buffer: $ } = this.context, r = $.findChild(this.index + 4, $.buffer[this.index + 3], e > 0 ? 1 : -1, t - this.context.start, e);
    return r < 0 ? null : new G(this.context, this, r);
  }
  get parent() {
    return this._parent || this.context.parent.nextSignificantParent();
  }
  externalSibling(t) {
    return this._parent ? null : this.context.parent.nextChild(
      this.context.index + t,
      t,
      0,
      4
      /* Side.DontCare */
    );
  }
  get nextSibling() {
    let { buffer: t } = this.context, e = t.buffer[this.index + 3];
    return e < (this._parent ? t.buffer[this._parent.index + 3] : t.buffer.length) ? new G(this.context, this._parent, e) : this.externalSibling(1);
  }
  get prevSibling() {
    let { buffer: t } = this.context, e = this._parent ? this._parent.index + 4 : 0;
    return this.index == e ? this.externalSibling(-1) : new G(this.context, this._parent, t.findChild(
      e,
      this.index,
      -1,
      0,
      4
      /* Side.DontCare */
    ));
  }
  get tree() {
    return null;
  }
  toTree() {
    let t = [], e = [], { buffer: s } = this.context, $ = this.index + 4, r = s.buffer[this.index + 3];
    if (r > $) {
      let i = s.buffer[this.index + 1];
      t.push(s.slice($, r, i)), e.push(0);
    }
    return new X(this.type, t, e, this.to - this.from);
  }
  /**
  @internal
  */
  toString() {
    return this.context.buffer.childString(this.index);
  }
}
function we(o) {
  if (!o.length)
    return null;
  let t = 0, e = o[0];
  for (let r = 1; r < o.length; r++) {
    let i = o[r];
    (i.from > e.from || i.to < e.to) && (e = i, t = r);
  }
  let s = e instanceof z && e.index < 0 ? null : e.parent, $ = o.slice();
  return s ? $[t] = s : $.splice(t, 1), new Ye($, e);
}
class Ye {
  constructor(t, e) {
    this.heads = t, this.node = e;
  }
  get next() {
    return we(this.heads);
  }
}
function Ke(o, t, e) {
  let s = o.resolveInner(t, e), $ = null;
  for (let r = s instanceof z ? s : s.context.parent; r; r = r.parent)
    if (r.index < 0) {
      let i = r.parent;
      ($ || ($ = [s])).push(i.resolve(t, e)), r = i;
    } else {
      let i = bt.get(r.tree);
      if (i && i.overlay && i.overlay[0].from <= t && i.overlay[i.overlay.length - 1].to >= t) {
        let n = new z(i.tree, i.overlay[0].from + r.from, -1, r);
        ($ || ($ = [s])).push(pt(n, t, e, !1));
      }
    }
  return $ ? we($) : s;
}
class vt {
  /**
  Shorthand for `.type.name`.
  */
  get name() {
    return this.type.name;
  }
  /**
  @internal
  */
  constructor(t, e = 0) {
    if (this.mode = e, this.buffer = null, this.stack = [], this.index = 0, this.bufferNode = null, t instanceof z)
      this.yieldNode(t);
    else {
      this._tree = t.context.parent, this.buffer = t.context;
      for (let s = t._parent; s; s = s._parent)
        this.stack.unshift(s.index);
      this.bufferNode = t, this.yieldBuf(t.index);
    }
  }
  yieldNode(t) {
    return t ? (this._tree = t, this.type = t.type, this.from = t.from, this.to = t.to, !0) : !1;
  }
  yieldBuf(t, e) {
    this.index = t;
    let { start: s, buffer: $ } = this.buffer;
    return this.type = e || $.set.types[$.buffer[t]], this.from = s + $.buffer[t + 1], this.to = s + $.buffer[t + 2], !0;
  }
  /**
  @internal
  */
  yield(t) {
    return t ? t instanceof z ? (this.buffer = null, this.yieldNode(t)) : (this.buffer = t.context, this.yieldBuf(t.index, t.type)) : !1;
  }
  /**
  @internal
  */
  toString() {
    return this.buffer ? this.buffer.buffer.childString(this.index) : this._tree.toString();
  }
  /**
  @internal
  */
  enterChild(t, e, s) {
    if (!this.buffer)
      return this.yield(this._tree.nextChild(t < 0 ? this._tree._tree.children.length - 1 : 0, t, e, s, this.mode));
    let { buffer: $ } = this.buffer, r = $.findChild(this.index + 4, $.buffer[this.index + 3], t, e - this.buffer.start, s);
    return r < 0 ? !1 : (this.stack.push(this.index), this.yieldBuf(r));
  }
  /**
  Move the cursor to this node's first child. When this returns
  false, the node has no child, and the cursor has not been moved.
  */
  firstChild() {
    return this.enterChild(
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  /**
  Move the cursor to this node's last child.
  */
  lastChild() {
    return this.enterChild(
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  /**
  Move the cursor to the first child that ends after `pos`.
  */
  childAfter(t) {
    return this.enterChild(
      1,
      t,
      2
      /* Side.After */
    );
  }
  /**
  Move to the last child that starts before `pos`.
  */
  childBefore(t) {
    return this.enterChild(
      -1,
      t,
      -2
      /* Side.Before */
    );
  }
  /**
  Move the cursor to the child around `pos`. If side is -1 the
  child may end at that position, when 1 it may start there. This
  will also enter [overlaid](#common.MountedTree.overlay)
  [mounted](#common.NodeProp^mounted) trees unless `overlays` is
  set to false.
  */
  enter(t, e, s = this.mode) {
    return this.buffer ? s & F.ExcludeBuffers ? !1 : this.enterChild(1, t, e) : this.yield(this._tree.enter(t, e, s));
  }
  /**
  Move to the node's parent node, if this isn't the top node.
  */
  parent() {
    if (!this.buffer)
      return this.yieldNode(this.mode & F.IncludeAnonymous ? this._tree._parent : this._tree.parent);
    if (this.stack.length)
      return this.yieldBuf(this.stack.pop());
    let t = this.mode & F.IncludeAnonymous ? this.buffer.parent : this.buffer.parent.nextSignificantParent();
    return this.buffer = null, this.yieldNode(t);
  }
  /**
  @internal
  */
  sibling(t) {
    if (!this.buffer)
      return this._tree._parent ? this.yield(this._tree.index < 0 ? null : this._tree._parent.nextChild(this._tree.index + t, t, 0, 4, this.mode)) : !1;
    let { buffer: e } = this.buffer, s = this.stack.length - 1;
    if (t < 0) {
      let $ = s < 0 ? 0 : this.stack[s] + 4;
      if (this.index != $)
        return this.yieldBuf(e.findChild(
          $,
          this.index,
          -1,
          0,
          4
          /* Side.DontCare */
        ));
    } else {
      let $ = e.buffer[this.index + 3];
      if ($ < (s < 0 ? e.buffer.length : e.buffer[this.stack[s] + 3]))
        return this.yieldBuf($);
    }
    return s < 0 ? this.yield(this.buffer.parent.nextChild(this.buffer.index + t, t, 0, 4, this.mode)) : !1;
  }
  /**
  Move to this node's next sibling, if any.
  */
  nextSibling() {
    return this.sibling(1);
  }
  /**
  Move to this node's previous sibling, if any.
  */
  prevSibling() {
    return this.sibling(-1);
  }
  atLastNode(t) {
    let e, s, { buffer: $ } = this;
    if ($) {
      if (t > 0) {
        if (this.index < $.buffer.buffer.length)
          return !1;
      } else
        for (let r = 0; r < this.index; r++)
          if ($.buffer.buffer[r + 3] < this.index)
            return !1;
      ({ index: e, parent: s } = $);
    } else
      ({ index: e, _parent: s } = this._tree);
    for (; s; { index: e, _parent: s } = s)
      if (e > -1)
        for (let r = e + t, i = t < 0 ? -1 : s._tree.children.length; r != i; r += t) {
          let n = s._tree.children[r];
          if (this.mode & F.IncludeAnonymous || n instanceof Q || !n.type.isAnonymous || Et(n))
            return !1;
        }
    return !0;
  }
  move(t, e) {
    if (e && this.enterChild(
      t,
      0,
      4
      /* Side.DontCare */
    ))
      return !0;
    for (; ; ) {
      if (this.sibling(t))
        return !0;
      if (this.atLastNode(t) || !this.parent())
        return !1;
    }
  }
  /**
  Move to the next node in a
  [pre-order](https://en.wikipedia.org/wiki/Tree_traversal#Pre-order,_NLR)
  traversal, going from a node to its first child or, if the
  current node is empty or `enter` is false, its next sibling or
  the next sibling of the first parent node that has one.
  */
  next(t = !0) {
    return this.move(1, t);
  }
  /**
  Move to the next node in a last-to-first pre-order traveral. A
  node is followed by its last child or, if it has none, its
  previous sibling or the previous sibling of the first parent
  node that has one.
  */
  prev(t = !0) {
    return this.move(-1, t);
  }
  /**
  Move the cursor to the innermost node that covers `pos`. If
  `side` is -1, it will enter nodes that end at `pos`. If it is 1,
  it will enter nodes that start at `pos`.
  */
  moveTo(t, e = 0) {
    for (; (this.from == this.to || (e < 1 ? this.from >= t : this.from > t) || (e > -1 ? this.to <= t : this.to < t)) && this.parent(); )
      ;
    for (; this.enterChild(1, t, e); )
      ;
    return this;
  }
  /**
  Get a [syntax node](#common.SyntaxNode) at the cursor's current
  position.
  */
  get node() {
    if (!this.buffer)
      return this._tree;
    let t = this.bufferNode, e = null, s = 0;
    if (t && t.context == this.buffer)
      t:
        for (let $ = this.index, r = this.stack.length; r >= 0; ) {
          for (let i = t; i; i = i._parent)
            if (i.index == $) {
              if ($ == this.index)
                return i;
              e = i, s = r + 1;
              break t;
            }
          $ = this.stack[--r];
        }
    for (let $ = s; $ < this.stack.length; $++)
      e = new G(this.buffer, e, this.stack[$]);
    return this.bufferNode = new G(this.buffer, e, this.index);
  }
  /**
  Get the [tree](#common.Tree) that represents the current node, if
  any. Will return null when the node is in a [tree
  buffer](#common.TreeBuffer).
  */
  get tree() {
    return this.buffer ? null : this._tree._tree;
  }
  /**
  Iterate over the current node and all its descendants, calling
  `enter` when entering a node and `leave`, if given, when leaving
  one. When `enter` returns `false`, any children of that node are
  skipped, and `leave` isn't called for it.
  */
  iterate(t, e) {
    for (let s = 0; ; ) {
      let $ = !1;
      if (this.type.isAnonymous || t(this) !== !1) {
        if (this.firstChild()) {
          s++;
          continue;
        }
        this.type.isAnonymous || ($ = !0);
      }
      for (; $ && e && e(this), $ = this.type.isAnonymous, !this.nextSibling(); ) {
        if (!s)
          return;
        this.parent(), s--, $ = !0;
      }
    }
  }
  /**
  Test whether the current node matches a given context—a sequence
  of direct parent node names. Empty strings in the context array
  are treated as wildcards.
  */
  matchContext(t) {
    if (!this.buffer)
      return Dt(this.node, t);
    let { buffer: e } = this.buffer, { types: s } = e.set;
    for (let $ = t.length - 1, r = this.stack.length - 1; $ >= 0; r--) {
      if (r < 0)
        return Dt(this.node, t, $);
      let i = s[e.buffer[this.stack[r]]];
      if (!i.isAnonymous) {
        if (t[$] && t[$] != i.name)
          return !1;
        $--;
      }
    }
    return !0;
  }
}
function Et(o) {
  return o.children.some((t) => t instanceof Q || !t.type.isAnonymous || Et(t));
}
function Ue(o) {
  var t;
  let { buffer: e, nodeSet: s, maxBufferLength: $ = be, reused: r = [], minRepeatType: i = s.types.length } = o, n = Array.isArray(e) ? new Ct(e, e.length) : e, h = s.types, l = 0, f = 0;
  function a(b, J, _, w, S, g) {
    let { id: W, start: O, end: m, size: I } = n, T = f;
    for (; I < 0; )
      if (n.next(), I == -1) {
        let U = r[W];
        _.push(U), w.push(O - b);
        return;
      } else if (I == -3) {
        l = W;
        return;
      } else if (I == -4) {
        f = W;
        return;
      } else
        throw new RangeError(`Unrecognized record size: ${I}`);
    let j = h[W], st, L, jt = O - b;
    if (m - O <= $ && (L = ot(n.pos - J, S))) {
      let U = new Uint16Array(L.size - L.skip), B = n.pos - L.size, V = U.length;
      for (; n.pos > B; )
        V = ht(L.start, U, V);
      st = new Q(U, m - L.start, s), jt = L.start - b;
    } else {
      let U = n.pos - I;
      n.next();
      let B = [], V = [], M = W >= i ? W : -1, $t = 0, _t = m;
      for (; n.pos > U; )
        M >= 0 && n.id == M && n.size >= 0 ? (n.end <= _t - $ && (k(B, V, O, $t, n.end, _t, M, T), $t = B.length, _t = n.end), n.next()) : g > 2500 ? p(O, U, B, V) : a(O, U, B, V, M, g + 1);
      if (M >= 0 && $t > 0 && $t < B.length && k(B, V, O, $t, O, _t, M, T), B.reverse(), V.reverse(), M > -1 && $t > 0) {
        let Lt = c(j);
        st = Gt(j, B, V, 0, B.length, 0, m - O, Lt, Lt);
      } else
        st = R(j, B, V, m - O, T - m);
    }
    _.push(st), w.push(jt);
  }
  function p(b, J, _, w) {
    let S = [], g = 0, W = -1;
    for (; n.pos > J; ) {
      let { id: O, start: m, end: I, size: T } = n;
      if (T > 4)
        n.next();
      else {
        if (W > -1 && m < W)
          break;
        W < 0 && (W = I - $), S.push(O, m, I), g++, n.next();
      }
    }
    if (g) {
      let O = new Uint16Array(g * 4), m = S[S.length - 2];
      for (let I = S.length - 3, T = 0; I >= 0; I -= 3)
        O[T++] = S[I], O[T++] = S[I + 1] - m, O[T++] = S[I + 2] - m, O[T++] = T;
      _.push(new Q(O, S[2] - m, s)), w.push(m - b);
    }
  }
  function c(b) {
    return (J, _, w) => {
      let S = 0, g = J.length - 1, W, O;
      if (g >= 0 && (W = J[g]) instanceof X) {
        if (!g && W.type == b && W.length == w)
          return W;
        (O = W.prop(x.lookAhead)) && (S = _[g] + W.length + O);
      }
      return R(b, J, _, w, S);
    };
  }
  function k(b, J, _, w, S, g, W, O) {
    let m = [], I = [];
    for (; b.length > w; )
      m.push(b.pop()), I.push(J.pop() + _ - S);
    b.push(R(s.types[W], m, I, g - S, O - g)), J.push(S - _);
  }
  function R(b, J, _, w, S = 0, g) {
    if (l) {
      let W = [x.contextHash, l];
      g = g ? [W].concat(g) : [W];
    }
    if (S > 25) {
      let W = [x.lookAhead, S];
      g = g ? [W].concat(g) : [W];
    }
    return new X(b, J, _, w, g);
  }
  function ot(b, J) {
    let _ = n.fork(), w = 0, S = 0, g = 0, W = _.end - $, O = { size: 0, start: 0, skip: 0 };
    t:
      for (let m = _.pos - b; _.pos > m; ) {
        let I = _.size;
        if (_.id == J && I >= 0) {
          O.size = w, O.start = S, O.skip = g, g += 4, w += 4, _.next();
          continue;
        }
        let T = _.pos - I;
        if (I < 0 || T < m || _.start < W)
          break;
        let j = _.id >= i ? 4 : 0, st = _.start;
        for (_.next(); _.pos > T; ) {
          if (_.size < 0)
            if (_.size == -3)
              j += 4;
            else
              break t;
          else
            _.id >= i && (j += 4);
          _.next();
        }
        S = st, w += I, g += j;
      }
    return (J < 0 || w == b) && (O.size = w, O.start = S, O.skip = g), O.size > 4 ? O : void 0;
  }
  function ht(b, J, _) {
    let { id: w, start: S, end: g, size: W } = n;
    if (n.next(), W >= 0 && w < i) {
      let O = _;
      if (W > 4) {
        let m = n.pos - (W - 4);
        for (; n.pos > m; )
          _ = ht(b, J, _);
      }
      J[--_] = O, J[--_] = g - b, J[--_] = S - b, J[--_] = w;
    } else
      W == -3 ? l = w : W == -4 && (f = w);
    return _;
  }
  let N = [], y = [];
  for (; n.pos > 0; )
    a(o.start || 0, o.bufferStart || 0, N, y, -1, 0);
  let Z = (t = o.length) !== null && t !== void 0 ? t : N.length ? y[0] + N[0].length : 0;
  return new X(h[o.topID], N.reverse(), y.reverse(), Z);
}
const se = /* @__PURE__ */ new WeakMap();
function gt(o, t) {
  if (!o.isAnonymous || t instanceof Q || t.type != o)
    return 1;
  let e = se.get(t);
  if (e == null) {
    e = 1;
    for (let s of t.children) {
      if (s.type != o || !(s instanceof X)) {
        e = 1;
        break;
      }
      e += gt(o, s);
    }
    se.set(t, e);
  }
  return e;
}
function Gt(o, t, e, s, $, r, i, n, h) {
  let l = 0;
  for (let k = s; k < $; k++)
    l += gt(o, t[k]);
  let f = Math.ceil(
    l * 1.5 / 8
    /* Balance.BranchFactor */
  ), a = [], p = [];
  function c(k, R, ot, ht, N) {
    for (let y = ot; y < ht; ) {
      let Z = y, b = R[y], J = gt(o, k[y]);
      for (y++; y < ht; y++) {
        let _ = gt(o, k[y]);
        if (J + _ >= f)
          break;
        J += _;
      }
      if (y == Z + 1) {
        if (J > f) {
          let _ = k[Z];
          c(_.children, _.positions, 0, _.children.length, R[Z] + N);
          continue;
        }
        a.push(k[Z]);
      } else {
        let _ = R[y - 1] + k[y - 1].length - b;
        a.push(Gt(o, k, R, Z, y, b, _, null, h));
      }
      p.push(b + N - r);
    }
  }
  return c(t, e, s, $, 0), (n || h)(a, p, i);
}
class et {
  /**
  Construct a tree fragment. You'll usually want to use
  [`addTree`](#common.TreeFragment^addTree) and
  [`applyChanges`](#common.TreeFragment^applyChanges) instead of
  calling this directly.
  */
  constructor(t, e, s, $, r = !1, i = !1) {
    this.from = t, this.to = e, this.tree = s, this.offset = $, this.open = (r ? 1 : 0) | (i ? 2 : 0);
  }
  /**
  Whether the start of the fragment represents the start of a
  parse, or the end of a change. (In the second case, it may not
  be safe to reuse some nodes at the start, depending on the
  parsing algorithm.)
  */
  get openStart() {
    return (this.open & 1) > 0;
  }
  /**
  Whether the end of the fragment represents the end of a
  full-document parse, or the start of a change.
  */
  get openEnd() {
    return (this.open & 2) > 0;
  }
  /**
  Create a set of fragments from a freshly parsed tree, or update
  an existing set of fragments by replacing the ones that overlap
  with a tree with content from the new tree. When `partial` is
  true, the parse is treated as incomplete, and the resulting
  fragment has [`openEnd`](#common.TreeFragment.openEnd) set to
  true.
  */
  static addTree(t, e = [], s = !1) {
    let $ = [new et(0, t.length, t, 0, !1, s)];
    for (let r of e)
      r.to > t.length && $.push(r);
    return $;
  }
  /**
  Apply a set of edits to an array of fragments, removing or
  splitting fragments as necessary to remove edited ranges, and
  adjusting offsets for fragments that moved.
  */
  static applyChanges(t, e, s = 128) {
    if (!e.length)
      return t;
    let $ = [], r = 1, i = t.length ? t[0] : null;
    for (let n = 0, h = 0, l = 0; ; n++) {
      let f = n < e.length ? e[n] : null, a = f ? f.fromA : 1e9;
      if (a - h >= s)
        for (; i && i.from < a; ) {
          let p = i;
          if (h >= p.from || a <= p.to || l) {
            let c = Math.max(p.from, h) - l, k = Math.min(p.to, a) - l;
            p = c >= k ? null : new et(c, k, p.tree, p.offset + l, n > 0, !!f);
          }
          if (p && $.push(p), i.to > a)
            break;
          i = r < t.length ? t[r++] : null;
        }
      if (!f)
        break;
      h = f.toA, l = f.toA - f.toB;
    }
    return $;
  }
}
class me {
  /**
  Start a parse, returning a [partial parse](#common.PartialParse)
  object. [`fragments`](#common.TreeFragment) can be passed in to
  make the parse incremental.
  
  By default, the entire input is parsed. You can pass `ranges`,
  which should be a sorted array of non-empty, non-overlapping
  ranges, to parse only those ranges. The tree returned in that
  case will start at `ranges[0].from`.
  */
  startParse(t, e, s) {
    return typeof t == "string" && (t = new Ae(t)), s = s ? s.length ? s.map(($) => new Pt($.from, $.to)) : [new Pt(0, 0)] : [new Pt(0, t.length)], this.createParse(t, e || [], s);
  }
  /**
  Run a full parse, returning the resulting tree.
  */
  parse(t, e, s) {
    let $ = this.startParse(t, e, s);
    for (; ; ) {
      let r = $.advance();
      if (r)
        return r;
    }
  }
}
class Ae {
  constructor(t) {
    this.string = t;
  }
  get length() {
    return this.string.length;
  }
  chunk(t) {
    return this.string.slice(t);
  }
  get lineChunks() {
    return !1;
  }
  read(t, e) {
    return this.string.slice(t, e);
  }
}
new x({ perNode: !0 });
class Jt {
  /**
  @internal
  */
  constructor(t, e, s, $, r, i, n, h, l, f = 0, a) {
    this.p = t, this.stack = e, this.state = s, this.reducePos = $, this.pos = r, this.score = i, this.buffer = n, this.bufferBase = h, this.curContext = l, this.lookAhead = f, this.parent = a;
  }
  /**
  @internal
  */
  toString() {
    return `[${this.stack.filter((t, e) => e % 3 == 0).concat(this.state)}]@${this.pos}${this.score ? "!" + this.score : ""}`;
  }
  // Start an empty stack
  /**
  @internal
  */
  static start(t, e, s = 0) {
    let $ = t.parser.context;
    return new Jt(t, [], e, s, s, 0, [], 0, $ ? new $e($, $.start) : null, 0, null);
  }
  /**
  The stack's current [context](#lr.ContextTracker) value, if
  any. Its type will depend on the context tracker's type
  parameter, or it will be `null` if there is no context
  tracker.
  */
  get context() {
    return this.curContext ? this.curContext.context : null;
  }
  // Push a state onto the stack, tracking its start position as well
  // as the buffer base at that point.
  /**
  @internal
  */
  pushState(t, e) {
    this.stack.push(this.state, e, this.bufferBase + this.buffer.length), this.state = t;
  }
  // Apply a reduce action
  /**
  @internal
  */
  reduce(t) {
    var e;
    let s = t >> 19, $ = t & 65535, { parser: r } = this.p, i = r.dynamicPrecedence($);
    if (i && (this.score += i), s == 0) {
      this.pushState(r.getGoto(this.state, $, !0), this.reducePos), $ < r.minRepeatTerm && this.storeNode($, this.reducePos, this.reducePos, 4, !0), this.reduceContext($, this.reducePos);
      return;
    }
    let n = this.stack.length - (s - 1) * 3 - (t & 262144 ? 6 : 0), h = n ? this.stack[n - 2] : this.p.ranges[0].from, l = this.reducePos - h;
    l >= 2e3 && !(!((e = this.p.parser.nodeSet.types[$]) === null || e === void 0) && e.isAnonymous) && (h == this.p.lastBigReductionStart ? (this.p.bigReductionCount++, this.p.lastBigReductionSize = l) : this.p.lastBigReductionSize < l && (this.p.bigReductionCount = 1, this.p.lastBigReductionStart = h, this.p.lastBigReductionSize = l));
    let f = n ? this.stack[n - 1] : 0, a = this.bufferBase + this.buffer.length - f;
    if ($ < r.minRepeatTerm || t & 131072) {
      let p = r.stateFlag(
        this.state,
        1
        /* StateFlag.Skipped */
      ) ? this.pos : this.reducePos;
      this.storeNode($, h, p, a + 4, !0);
    }
    if (t & 262144)
      this.state = this.stack[n];
    else {
      let p = this.stack[n - 3];
      this.state = r.getGoto(p, $, !0);
    }
    for (; this.stack.length > n; )
      this.stack.pop();
    this.reduceContext($, h);
  }
  // Shift a value into the buffer
  /**
  @internal
  */
  storeNode(t, e, s, $ = 4, r = !1) {
    if (t == 0 && (!this.stack.length || this.stack[this.stack.length - 1] < this.buffer.length + this.bufferBase)) {
      let i = this, n = this.buffer.length;
      if (n == 0 && i.parent && (n = i.bufferBase - i.parent.bufferBase, i = i.parent), n > 0 && i.buffer[n - 4] == 0 && i.buffer[n - 1] > -1) {
        if (e == s)
          return;
        if (i.buffer[n - 2] >= e) {
          i.buffer[n - 2] = s;
          return;
        }
      }
    }
    if (!r || this.pos == s)
      this.buffer.push(t, e, s, $);
    else {
      let i = this.buffer.length;
      if (i > 0 && this.buffer[i - 4] != 0)
        for (; i > 0 && this.buffer[i - 2] > s; )
          this.buffer[i] = this.buffer[i - 4], this.buffer[i + 1] = this.buffer[i - 3], this.buffer[i + 2] = this.buffer[i - 2], this.buffer[i + 3] = this.buffer[i - 1], i -= 4, $ > 4 && ($ -= 4);
      this.buffer[i] = t, this.buffer[i + 1] = e, this.buffer[i + 2] = s, this.buffer[i + 3] = $;
    }
  }
  // Apply a shift action
  /**
  @internal
  */
  shift(t, e, s, $) {
    if (t & 131072)
      this.pushState(t & 65535, this.pos);
    else if (t & 262144)
      this.pos = $, this.shiftContext(e, s), e <= this.p.parser.maxNode && this.buffer.push(e, s, $, 4);
    else {
      let r = t, { parser: i } = this.p;
      ($ > this.pos || e <= i.maxNode) && (this.pos = $, i.stateFlag(
        r,
        1
        /* StateFlag.Skipped */
      ) || (this.reducePos = $)), this.pushState(r, s), this.shiftContext(e, s), e <= i.maxNode && this.buffer.push(e, s, $, 4);
    }
  }
  // Apply an action
  /**
  @internal
  */
  apply(t, e, s, $) {
    t & 65536 ? this.reduce(t) : this.shift(t, e, s, $);
  }
  // Add a prebuilt (reused) node into the buffer.
  /**
  @internal
  */
  useNode(t, e) {
    let s = this.p.reused.length - 1;
    (s < 0 || this.p.reused[s] != t) && (this.p.reused.push(t), s++);
    let $ = this.pos;
    this.reducePos = this.pos = $ + t.length, this.pushState(e, $), this.buffer.push(
      s,
      $,
      this.reducePos,
      -1
      /* size == -1 means this is a reused value */
    ), this.curContext && this.updateContext(this.curContext.tracker.reuse(this.curContext.context, t, this, this.p.stream.reset(this.pos - t.length)));
  }
  // Split the stack. Due to the buffer sharing and the fact
  // that `this.stack` tends to stay quite shallow, this isn't very
  // expensive.
  /**
  @internal
  */
  split() {
    let t = this, e = t.buffer.length;
    for (; e > 0 && t.buffer[e - 2] > t.reducePos; )
      e -= 4;
    let s = t.buffer.slice(e), $ = t.bufferBase + e;
    for (; t && $ == t.bufferBase; )
      t = t.parent;
    return new Jt(this.p, this.stack.slice(), this.state, this.reducePos, this.pos, this.score, s, $, this.curContext, this.lookAhead, t);
  }
  // Try to recover from an error by 'deleting' (ignoring) one token.
  /**
  @internal
  */
  recoverByDelete(t, e) {
    let s = t <= this.p.parser.maxNode;
    s && this.storeNode(t, this.pos, e, 4), this.storeNode(0, this.pos, e, s ? 8 : 4), this.pos = this.reducePos = e, this.score -= 190;
  }
  /**
  Check if the given term would be able to be shifted (optionally
  after some reductions) on this stack. This can be useful for
  external tokenizers that want to make sure they only provide a
  given token when it applies.
  */
  canShift(t) {
    for (let e = new Ce(this); ; ) {
      let s = this.p.parser.stateSlot(
        e.state,
        4
        /* ParseState.DefaultReduce */
      ) || this.p.parser.hasAction(e.state, t);
      if (s == 0)
        return !1;
      if (!(s & 65536))
        return !0;
      e.reduce(s);
    }
  }
  // Apply up to Recover.MaxNext recovery actions that conceptually
  // inserts some missing token or rule.
  /**
  @internal
  */
  recoverByInsert(t) {
    if (this.stack.length >= 300)
      return [];
    let e = this.p.parser.nextStates(this.state);
    if (e.length > 8 || this.stack.length >= 120) {
      let $ = [];
      for (let r = 0, i; r < e.length; r += 2)
        (i = e[r + 1]) != this.state && this.p.parser.hasAction(i, t) && $.push(e[r], i);
      if (this.stack.length < 120)
        for (let r = 0; $.length < 8 && r < e.length; r += 2) {
          let i = e[r + 1];
          $.some((n, h) => h & 1 && n == i) || $.push(e[r], i);
        }
      e = $;
    }
    let s = [];
    for (let $ = 0; $ < e.length && s.length < 4; $ += 2) {
      let r = e[$ + 1];
      if (r == this.state)
        continue;
      let i = this.split();
      i.pushState(r, this.pos), i.storeNode(0, i.pos, i.pos, 4, !0), i.shiftContext(e[$], this.pos), i.reducePos = this.pos, i.score -= 200, s.push(i);
    }
    return s;
  }
  // Force a reduce, if possible. Return false if that can't
  // be done.
  /**
  @internal
  */
  forceReduce() {
    let { parser: t } = this.p, e = t.stateSlot(
      this.state,
      5
      /* ParseState.ForcedReduce */
    );
    if (!(e & 65536))
      return !1;
    if (!t.validAction(this.state, e)) {
      let s = e >> 19, $ = e & 65535, r = this.stack.length - s * 3;
      if (r < 0 || t.getGoto(this.stack[r], $, !1) < 0) {
        let i = this.findForcedReduction();
        if (i == null)
          return !1;
        e = i;
      }
      this.storeNode(0, this.pos, this.pos, 4, !0), this.score -= 100;
    }
    return this.reducePos = this.pos, this.reduce(e), !0;
  }
  /**
  Try to scan through the automaton to find some kind of reduction
  that can be applied. Used when the regular ForcedReduce field
  isn't a valid action. @internal
  */
  findForcedReduction() {
    let { parser: t } = this.p, e = [], s = ($, r) => {
      if (!e.includes($))
        return e.push($), t.allActions($, (i) => {
          if (!(i & 393216))
            if (i & 65536) {
              let n = (i >> 19) - r;
              if (n > 1) {
                let h = i & 65535, l = this.stack.length - n * 3;
                if (l >= 0 && t.getGoto(this.stack[l], h, !1) >= 0)
                  return n << 19 | 65536 | h;
              }
            } else {
              let n = s(i, r + 1);
              if (n != null)
                return n;
            }
        });
    };
    return s(this.state, 0);
  }
  /**
  @internal
  */
  forceAll() {
    for (; !this.p.parser.stateFlag(
      this.state,
      2
      /* StateFlag.Accepting */
    ); )
      if (!this.forceReduce()) {
        this.storeNode(0, this.pos, this.pos, 4, !0);
        break;
      }
    return this;
  }
  /**
  Check whether this state has no further actions (assumed to be a direct descendant of the
  top state, since any other states must be able to continue
  somehow). @internal
  */
  get deadEnd() {
    if (this.stack.length != 3)
      return !1;
    let { parser: t } = this.p;
    return t.data[t.stateSlot(
      this.state,
      1
      /* ParseState.Actions */
    )] == 65535 && !t.stateSlot(
      this.state,
      4
      /* ParseState.DefaultReduce */
    );
  }
  /**
  Restart the stack (put it back in its start state). Only safe
  when this.stack.length == 3 (state is directly below the top
  state). @internal
  */
  restart() {
    this.storeNode(0, this.pos, this.pos, 4, !0), this.state = this.stack[0], this.stack.length = 0;
  }
  /**
  @internal
  */
  sameState(t) {
    if (this.state != t.state || this.stack.length != t.stack.length)
      return !1;
    for (let e = 0; e < this.stack.length; e += 3)
      if (this.stack[e] != t.stack[e])
        return !1;
    return !0;
  }
  /**
  Get the parser used by this stack.
  */
  get parser() {
    return this.p.parser;
  }
  /**
  Test whether a given dialect (by numeric ID, as exported from
  the terms file) is enabled.
  */
  dialectEnabled(t) {
    return this.p.parser.dialect.flags[t];
  }
  shiftContext(t, e) {
    this.curContext && this.updateContext(this.curContext.tracker.shift(this.curContext.context, t, this, this.p.stream.reset(e)));
  }
  reduceContext(t, e) {
    this.curContext && this.updateContext(this.curContext.tracker.reduce(this.curContext.context, t, this, this.p.stream.reset(e)));
  }
  /**
  @internal
  */
  emitContext() {
    let t = this.buffer.length - 1;
    (t < 0 || this.buffer[t] != -3) && this.buffer.push(this.curContext.hash, this.pos, this.pos, -3);
  }
  /**
  @internal
  */
  emitLookAhead() {
    let t = this.buffer.length - 1;
    (t < 0 || this.buffer[t] != -4) && this.buffer.push(this.lookAhead, this.pos, this.pos, -4);
  }
  updateContext(t) {
    if (t != this.curContext.context) {
      let e = new $e(this.curContext.tracker, t);
      e.hash != this.curContext.hash && this.emitContext(), this.curContext = e;
    }
  }
  /**
  @internal
  */
  setLookAhead(t) {
    t > this.lookAhead && (this.emitLookAhead(), this.lookAhead = t);
  }
  /**
  @internal
  */
  close() {
    this.curContext && this.curContext.tracker.strict && this.emitContext(), this.lookAhead > 0 && this.emitLookAhead();
  }
}
class $e {
  constructor(t, e) {
    this.tracker = t, this.context = e, this.hash = t.strict ? t.hash(e) : 0;
  }
}
class Ce {
  constructor(t) {
    this.start = t, this.state = t.state, this.stack = t.stack, this.base = this.stack.length;
  }
  reduce(t) {
    let e = t & 65535, s = t >> 19;
    s == 0 ? (this.stack == this.start.stack && (this.stack = this.stack.slice()), this.stack.push(this.state, 0, 0), this.base += 3) : this.base -= (s - 1) * 3;
    let $ = this.start.p.parser.getGoto(this.stack[this.base - 3], e, !0);
    this.state = $;
  }
}
class It {
  constructor(t, e, s) {
    this.stack = t, this.pos = e, this.index = s, this.buffer = t.buffer, this.index == 0 && this.maybeNext();
  }
  static create(t, e = t.bufferBase + t.buffer.length) {
    return new It(t, e, e - t.bufferBase);
  }
  maybeNext() {
    let t = this.stack.parent;
    t != null && (this.index = this.stack.bufferBase - t.bufferBase, this.stack = t, this.buffer = t.buffer);
  }
  get id() {
    return this.buffer[this.index - 4];
  }
  get start() {
    return this.buffer[this.index - 3];
  }
  get end() {
    return this.buffer[this.index - 2];
  }
  get size() {
    return this.buffer[this.index - 1];
  }
  next() {
    this.index -= 4, this.pos -= 4, this.index == 0 && this.maybeNext();
  }
  fork() {
    return new It(this.stack, this.pos, this.index);
  }
}
function ct(o, t = Uint16Array) {
  if (typeof o != "string")
    return o;
  let e = null;
  for (let s = 0, $ = 0; s < o.length; ) {
    let r = 0;
    for (; ; ) {
      let i = o.charCodeAt(s++), n = !1;
      if (i == 126) {
        r = 65535;
        break;
      }
      i >= 92 && i--, i >= 34 && i--;
      let h = i - 32;
      if (h >= 46 && (h -= 46, n = !0), r += h, n)
        break;
      r *= 46;
    }
    e ? e[$++] = r : e = new t(r);
  }
  return e;
}
class xt {
  constructor() {
    this.start = -1, this.value = -1, this.end = -1, this.extended = -1, this.lookAhead = 0, this.mask = 0, this.context = 0;
  }
}
const re = new xt();
class Ee {
  /**
  @internal
  */
  constructor(t, e) {
    this.input = t, this.ranges = e, this.chunk = "", this.chunkOff = 0, this.chunk2 = "", this.chunk2Pos = 0, this.next = -1, this.token = re, this.rangeIndex = 0, this.pos = this.chunkPos = e[0].from, this.range = e[0], this.end = e[e.length - 1].to, this.readNext();
  }
  /**
  @internal
  */
  resolveOffset(t, e) {
    let s = this.range, $ = this.rangeIndex, r = this.pos + t;
    for (; r < s.from; ) {
      if (!$)
        return null;
      let i = this.ranges[--$];
      r -= s.from - i.to, s = i;
    }
    for (; e < 0 ? r > s.to : r >= s.to; ) {
      if ($ == this.ranges.length - 1)
        return null;
      let i = this.ranges[++$];
      r += i.from - s.to, s = i;
    }
    return r;
  }
  /**
  @internal
  */
  clipPos(t) {
    if (t >= this.range.from && t < this.range.to)
      return t;
    for (let e of this.ranges)
      if (e.to > t)
        return Math.max(t, e.from);
    return this.end;
  }
  /**
  Look at a code unit near the stream position. `.peek(0)` equals
  `.next`, `.peek(-1)` gives you the previous character, and so
  on.
  
  Note that looking around during tokenizing creates dependencies
  on potentially far-away content, which may reduce the
  effectiveness incremental parsing—when looking forward—or even
  cause invalid reparses when looking backward more than 25 code
  units, since the library does not track lookbehind.
  */
  peek(t) {
    let e = this.chunkOff + t, s, $;
    if (e >= 0 && e < this.chunk.length)
      s = this.pos + t, $ = this.chunk.charCodeAt(e);
    else {
      let r = this.resolveOffset(t, 1);
      if (r == null)
        return -1;
      if (s = r, s >= this.chunk2Pos && s < this.chunk2Pos + this.chunk2.length)
        $ = this.chunk2.charCodeAt(s - this.chunk2Pos);
      else {
        let i = this.rangeIndex, n = this.range;
        for (; n.to <= s; )
          n = this.ranges[++i];
        this.chunk2 = this.input.chunk(this.chunk2Pos = s), s + this.chunk2.length > n.to && (this.chunk2 = this.chunk2.slice(0, n.to - s)), $ = this.chunk2.charCodeAt(0);
      }
    }
    return s >= this.token.lookAhead && (this.token.lookAhead = s + 1), $;
  }
  /**
  Accept a token. By default, the end of the token is set to the
  current stream position, but you can pass an offset (relative to
  the stream position) to change that.
  */
  acceptToken(t, e = 0) {
    let s = e ? this.resolveOffset(e, -1) : this.pos;
    if (s == null || s < this.token.start)
      throw new RangeError("Token end out of bounds");
    this.token.value = t, this.token.end = s;
  }
  getChunk() {
    if (this.pos >= this.chunk2Pos && this.pos < this.chunk2Pos + this.chunk2.length) {
      let { chunk: t, chunkPos: e } = this;
      this.chunk = this.chunk2, this.chunkPos = this.chunk2Pos, this.chunk2 = t, this.chunk2Pos = e, this.chunkOff = this.pos - this.chunkPos;
    } else {
      this.chunk2 = this.chunk, this.chunk2Pos = this.chunkPos;
      let t = this.input.chunk(this.pos), e = this.pos + t.length;
      this.chunk = e > this.range.to ? t.slice(0, this.range.to - this.pos) : t, this.chunkPos = this.pos, this.chunkOff = 0;
    }
  }
  readNext() {
    return this.chunkOff >= this.chunk.length && (this.getChunk(), this.chunkOff == this.chunk.length) ? this.next = -1 : this.next = this.chunk.charCodeAt(this.chunkOff);
  }
  /**
  Move the stream forward N (defaults to 1) code units. Returns
  the new value of [`next`](#lr.InputStream.next).
  */
  advance(t = 1) {
    for (this.chunkOff += t; this.pos + t >= this.range.to; ) {
      if (this.rangeIndex == this.ranges.length - 1)
        return this.setDone();
      t -= this.range.to - this.pos, this.range = this.ranges[++this.rangeIndex], this.pos = this.range.from;
    }
    return this.pos += t, this.pos >= this.token.lookAhead && (this.token.lookAhead = this.pos + 1), this.readNext();
  }
  setDone() {
    return this.pos = this.chunkPos = this.end, this.range = this.ranges[this.rangeIndex = this.ranges.length - 1], this.chunk = "", this.next = -1;
  }
  /**
  @internal
  */
  reset(t, e) {
    if (e ? (this.token = e, e.start = t, e.lookAhead = t + 1, e.value = e.extended = -1) : this.token = re, this.pos != t) {
      if (this.pos = t, t == this.end)
        return this.setDone(), this;
      for (; t < this.range.from; )
        this.range = this.ranges[--this.rangeIndex];
      for (; t >= this.range.to; )
        this.range = this.ranges[++this.rangeIndex];
      t >= this.chunkPos && t < this.chunkPos + this.chunk.length ? this.chunkOff = t - this.chunkPos : (this.chunk = "", this.chunkOff = 0), this.readNext();
    }
    return this;
  }
  /**
  @internal
  */
  read(t, e) {
    if (t >= this.chunkPos && e <= this.chunkPos + this.chunk.length)
      return this.chunk.slice(t - this.chunkPos, e - this.chunkPos);
    if (t >= this.chunk2Pos && e <= this.chunk2Pos + this.chunk2.length)
      return this.chunk2.slice(t - this.chunk2Pos, e - this.chunk2Pos);
    if (t >= this.range.from && e <= this.range.to)
      return this.input.read(t, e);
    let s = "";
    for (let $ of this.ranges) {
      if ($.from >= e)
        break;
      $.to > t && (s += this.input.read(Math.max($.from, t), Math.min($.to, e)));
    }
    return s;
  }
}
class rt {
  constructor(t, e) {
    this.data = t, this.id = e;
  }
  token(t, e) {
    let { parser: s } = e.p;
    Ge(this.data, t, e, this.id, s.data, s.tokenPrecTable);
  }
}
rt.prototype.contextual = rt.prototype.fallback = rt.prototype.extend = !1;
rt.prototype.fallback = rt.prototype.extend = !1;
function Ge(o, t, e, s, $, r) {
  let i = 0, n = 1 << s, { dialect: h } = e.p.parser;
  t:
    for (; n & o[i]; ) {
      let l = o[i + 1];
      for (let c = i + 3; c < l; c += 2)
        if ((o[c + 1] & n) > 0) {
          let k = o[c];
          if (h.allows(k) && (t.token.value == -1 || t.token.value == k || Qe(k, t.token.value, $, r))) {
            t.acceptToken(k);
            break;
          }
        }
      let f = t.next, a = 0, p = o[i + 2];
      if (t.next < 0 && p > a && o[l + p * 3 - 3] == 65535) {
        i = o[l + p * 3 - 1];
        continue t;
      }
      for (; a < p; ) {
        let c = a + p >> 1, k = l + c + (c << 1), R = o[k], ot = o[k + 1] || 65536;
        if (f < R)
          p = c;
        else if (f >= ot)
          a = c + 1;
        else {
          i = o[k + 2], t.advance();
          continue t;
        }
      }
      break;
    }
}
function ie(o, t, e) {
  for (let s = t, $; ($ = o[s]) != 65535; s++)
    if ($ == e)
      return s - t;
  return -1;
}
function Qe(o, t, e, s) {
  let $ = ie(e, s, t);
  return $ < 0 || ie(e, s, o) < $;
}
const q = typeof process < "u" && process.env && /\bparse\b/.test(process.env.LOG);
let Rt = null;
function ne(o, t, e) {
  let s = o.cursor(F.IncludeAnonymous);
  for (s.moveTo(t); ; )
    if (!(e < 0 ? s.childBefore(t) : s.childAfter(t)))
      for (; ; ) {
        if ((e < 0 ? s.to < t : s.from > t) && !s.type.isError)
          return e < 0 ? Math.max(0, Math.min(
            s.to - 1,
            t - 25
            /* Safety.Margin */
          )) : Math.min(o.length, Math.max(
            s.from + 1,
            t + 25
            /* Safety.Margin */
          ));
        if (e < 0 ? s.prevSibling() : s.nextSibling())
          break;
        if (!s.parent())
          return e < 0 ? 0 : o.length;
      }
}
class Ne {
  constructor(t, e) {
    this.fragments = t, this.nodeSet = e, this.i = 0, this.fragment = null, this.safeFrom = -1, this.safeTo = -1, this.trees = [], this.start = [], this.index = [], this.nextFragment();
  }
  nextFragment() {
    let t = this.fragment = this.i == this.fragments.length ? null : this.fragments[this.i++];
    if (t) {
      for (this.safeFrom = t.openStart ? ne(t.tree, t.from + t.offset, 1) - t.offset : t.from, this.safeTo = t.openEnd ? ne(t.tree, t.to + t.offset, -1) - t.offset : t.to; this.trees.length; )
        this.trees.pop(), this.start.pop(), this.index.pop();
      this.trees.push(t.tree), this.start.push(-t.offset), this.index.push(0), this.nextStart = this.safeFrom;
    } else
      this.nextStart = 1e9;
  }
  // `pos` must be >= any previously given `pos` for this cursor
  nodeAt(t) {
    if (t < this.nextStart)
      return null;
    for (; this.fragment && this.safeTo <= t; )
      this.nextFragment();
    if (!this.fragment)
      return null;
    for (; ; ) {
      let e = this.trees.length - 1;
      if (e < 0)
        return this.nextFragment(), null;
      let s = this.trees[e], $ = this.index[e];
      if ($ == s.children.length) {
        this.trees.pop(), this.start.pop(), this.index.pop();
        continue;
      }
      let r = s.children[$], i = this.start[e] + s.positions[$];
      if (i > t)
        return this.nextStart = i, null;
      if (r instanceof X) {
        if (i == t) {
          if (i < this.safeFrom)
            return null;
          let n = i + r.length;
          if (n <= this.safeTo) {
            let h = r.prop(x.lookAhead);
            if (!h || n + h < this.fragment.to)
              return r;
          }
        }
        this.index[e]++, i + r.length >= Math.max(this.safeFrom, t) && (this.trees.push(r), this.start.push(i), this.index.push(0));
      } else
        this.index[e]++, this.nextStart = i + r.length;
    }
  }
}
class Ze {
  constructor(t, e) {
    this.stream = e, this.tokens = [], this.mainToken = null, this.actions = [], this.tokens = t.tokenizers.map((s) => new xt());
  }
  getActions(t) {
    let e = 0, s = null, { parser: $ } = t.p, { tokenizers: r } = $, i = $.stateSlot(
      t.state,
      3
      /* ParseState.TokenizerMask */
    ), n = t.curContext ? t.curContext.hash : 0, h = 0;
    for (let l = 0; l < r.length; l++) {
      if (!(1 << l & i))
        continue;
      let f = r[l], a = this.tokens[l];
      if (!(s && !f.fallback) && ((f.contextual || a.start != t.pos || a.mask != i || a.context != n) && (this.updateCachedToken(a, f, t), a.mask = i, a.context = n), a.lookAhead > a.end + 25 && (h = Math.max(a.lookAhead, h)), a.value != 0)) {
        let p = e;
        if (a.extended > -1 && (e = this.addActions(t, a.extended, a.end, e)), e = this.addActions(t, a.value, a.end, e), !f.extend && (s = a, e > p))
          break;
      }
    }
    for (; this.actions.length > e; )
      this.actions.pop();
    return h && t.setLookAhead(h), !s && t.pos == this.stream.end && (s = new xt(), s.value = t.p.parser.eofTerm, s.start = s.end = t.pos, e = this.addActions(t, s.value, s.end, e)), this.mainToken = s, this.actions;
  }
  getMainToken(t) {
    if (this.mainToken)
      return this.mainToken;
    let e = new xt(), { pos: s, p: $ } = t;
    return e.start = s, e.end = Math.min(s + 1, $.stream.end), e.value = s == $.stream.end ? $.parser.eofTerm : 0, e;
  }
  updateCachedToken(t, e, s) {
    let $ = this.stream.clipPos(s.pos);
    if (e.token(this.stream.reset($, t), s), t.value > -1) {
      let { parser: r } = s.p;
      for (let i = 0; i < r.specialized.length; i++)
        if (r.specialized[i] == t.value) {
          let n = r.specializers[i](this.stream.read(t.start, t.end), s);
          if (n >= 0 && s.p.parser.dialect.allows(n >> 1)) {
            n & 1 ? t.extended = n >> 1 : t.value = n >> 1;
            break;
          }
        }
    } else
      t.value = 0, t.end = this.stream.clipPos($ + 1);
  }
  putAction(t, e, s, $) {
    for (let r = 0; r < $; r += 3)
      if (this.actions[r] == t)
        return $;
    return this.actions[$++] = t, this.actions[$++] = e, this.actions[$++] = s, $;
  }
  addActions(t, e, s, $) {
    let { state: r } = t, { parser: i } = t.p, { data: n } = i;
    for (let h = 0; h < 2; h++)
      for (let l = i.stateSlot(
        r,
        h ? 2 : 1
        /* ParseState.Actions */
      ); ; l += 3) {
        if (n[l] == 65535)
          if (n[l + 1] == 1)
            l = A(n, l + 2);
          else {
            $ == 0 && n[l + 1] == 2 && ($ = this.putAction(A(n, l + 2), e, s, $));
            break;
          }
        n[l] == e && ($ = this.putAction(A(n, l + 1), e, s, $));
      }
    return $;
  }
}
class je {
  constructor(t, e, s, $) {
    this.parser = t, this.input = e, this.ranges = $, this.recovering = 0, this.nextStackID = 9812, this.minStackPos = 0, this.reused = [], this.stoppedAt = null, this.lastBigReductionStart = -1, this.lastBigReductionSize = 0, this.bigReductionCount = 0, this.stream = new Ee(e, $), this.tokens = new Ze(t, this.stream), this.topTerm = t.top[1];
    let { from: r } = $[0];
    this.stacks = [Jt.start(this, t.top[0], r)], this.fragments = s.length && this.stream.end - r > t.bufferLength * 4 ? new Ne(s, t.nodeSet) : null;
  }
  get parsedPos() {
    return this.minStackPos;
  }
  // Move the parser forward. This will process all parse stacks at
  // `this.pos` and try to advance them to a further position. If no
  // stack for such a position is found, it'll start error-recovery.
  //
  // When the parse is finished, this will return a syntax tree. When
  // not, it returns `null`.
  advance() {
    let t = this.stacks, e = this.minStackPos, s = this.stacks = [], $, r;
    if (this.bigReductionCount > 300 && t.length == 1) {
      let [i] = t;
      for (; i.forceReduce() && i.stack.length && i.stack[i.stack.length - 2] >= this.lastBigReductionStart; )
        ;
      this.bigReductionCount = this.lastBigReductionSize = 0;
    }
    for (let i = 0; i < t.length; i++) {
      let n = t[i];
      for (; ; ) {
        if (this.tokens.mainToken = null, n.pos > e)
          s.push(n);
        else {
          if (this.advanceStack(n, s, t))
            continue;
          {
            $ || ($ = [], r = []), $.push(n);
            let h = this.tokens.getMainToken(n);
            r.push(h.value, h.end);
          }
        }
        break;
      }
    }
    if (!s.length) {
      let i = $ && Me($);
      if (i)
        return q && console.log("Finish with " + this.stackID(i)), this.stackToTree(i);
      if (this.parser.strict)
        throw q && $ && console.log("Stuck with token " + (this.tokens.mainToken ? this.parser.getName(this.tokens.mainToken.value) : "none")), new SyntaxError("No parse at " + e);
      this.recovering || (this.recovering = 5);
    }
    if (this.recovering && $) {
      let i = this.stoppedAt != null && $[0].pos > this.stoppedAt ? $[0] : this.runRecovery($, r, s);
      if (i)
        return q && console.log("Force-finish " + this.stackID(i)), this.stackToTree(i.forceAll());
    }
    if (this.recovering) {
      let i = this.recovering == 1 ? 1 : this.recovering * 3;
      if (s.length > i)
        for (s.sort((n, h) => h.score - n.score); s.length > i; )
          s.pop();
      s.some((n) => n.reducePos > e) && this.recovering--;
    } else if (s.length > 1) {
      t:
        for (let i = 0; i < s.length - 1; i++) {
          let n = s[i];
          for (let h = i + 1; h < s.length; h++) {
            let l = s[h];
            if (n.sameState(l) || n.buffer.length > 500 && l.buffer.length > 500)
              if ((n.score - l.score || n.buffer.length - l.buffer.length) > 0)
                s.splice(h--, 1);
              else {
                s.splice(i--, 1);
                continue t;
              }
          }
        }
      s.length > 12 && s.splice(
        12,
        s.length - 12
        /* Rec.MaxStackCount */
      );
    }
    this.minStackPos = s[0].pos;
    for (let i = 1; i < s.length; i++)
      s[i].pos < this.minStackPos && (this.minStackPos = s[i].pos);
    return null;
  }
  stopAt(t) {
    if (this.stoppedAt != null && this.stoppedAt < t)
      throw new RangeError("Can't move stoppedAt forward");
    this.stoppedAt = t;
  }
  // Returns an updated version of the given stack, or null if the
  // stack can't advance normally. When `split` and `stacks` are
  // given, stacks split off by ambiguous operations will be pushed to
  // `split`, or added to `stacks` if they move `pos` forward.
  advanceStack(t, e, s) {
    let $ = t.pos, { parser: r } = this, i = q ? this.stackID(t) + " -> " : "";
    if (this.stoppedAt != null && $ > this.stoppedAt)
      return t.forceReduce() ? t : null;
    if (this.fragments) {
      let l = t.curContext && t.curContext.tracker.strict, f = l ? t.curContext.hash : 0;
      for (let a = this.fragments.nodeAt($); a; ) {
        let p = this.parser.nodeSet.types[a.type.id] == a.type ? r.getGoto(t.state, a.type.id) : -1;
        if (p > -1 && a.length && (!l || (a.prop(x.contextHash) || 0) == f))
          return t.useNode(a, p), q && console.log(i + this.stackID(t) + ` (via reuse of ${r.getName(a.type.id)})`), !0;
        if (!(a instanceof X) || a.children.length == 0 || a.positions[0] > 0)
          break;
        let c = a.children[0];
        if (c instanceof X && a.positions[0] == 0)
          a = c;
        else
          break;
      }
    }
    let n = r.stateSlot(
      t.state,
      4
      /* ParseState.DefaultReduce */
    );
    if (n > 0)
      return t.reduce(n), q && console.log(i + this.stackID(t) + ` (via always-reduce ${r.getName(
        n & 65535
        /* Action.ValueMask */
      )})`), !0;
    if (t.stack.length >= 8400)
      for (; t.stack.length > 6e3 && t.forceReduce(); )
        ;
    let h = this.tokens.getActions(t);
    for (let l = 0; l < h.length; ) {
      let f = h[l++], a = h[l++], p = h[l++], c = l == h.length || !s, k = c ? t : t.split(), R = this.tokens.mainToken;
      if (k.apply(f, a, R ? R.start : k.pos, p), q && console.log(i + this.stackID(k) + ` (via ${f & 65536 ? `reduce of ${r.getName(
        f & 65535
        /* Action.ValueMask */
      )}` : "shift"} for ${r.getName(a)} @ ${$}${k == t ? "" : ", split"})`), c)
        return !0;
      k.pos > $ ? e.push(k) : s.push(k);
    }
    return !1;
  }
  // Advance a given stack forward as far as it will go. Returns the
  // (possibly updated) stack if it got stuck, or null if it moved
  // forward and was given to `pushStackDedup`.
  advanceFully(t, e) {
    let s = t.pos;
    for (; ; ) {
      if (!this.advanceStack(t, null, null))
        return !1;
      if (t.pos > s)
        return oe(t, e), !0;
    }
  }
  runRecovery(t, e, s) {
    let $ = null, r = !1;
    for (let i = 0; i < t.length; i++) {
      let n = t[i], h = e[i << 1], l = e[(i << 1) + 1], f = q ? this.stackID(n) + " -> " : "";
      if (n.deadEnd && (r || (r = !0, n.restart(), q && console.log(f + this.stackID(n) + " (restarted)"), this.advanceFully(n, s))))
        continue;
      let a = n.split(), p = f;
      for (let c = 0; a.forceReduce() && c < 10 && (q && console.log(p + this.stackID(a) + " (via force-reduce)"), !this.advanceFully(a, s)); c++)
        q && (p = this.stackID(a) + " -> ");
      for (let c of n.recoverByInsert(h))
        q && console.log(f + this.stackID(c) + " (via recover-insert)"), this.advanceFully(c, s);
      this.stream.end > n.pos ? (l == n.pos && (l++, h = 0), n.recoverByDelete(h, l), q && console.log(f + this.stackID(n) + ` (via recover-delete ${this.parser.getName(h)})`), oe(n, s)) : (!$ || $.score < n.score) && ($ = n);
    }
    return $;
  }
  // Convert the stack's buffer to a syntax tree.
  stackToTree(t) {
    return t.close(), X.build({
      buffer: It.create(t),
      nodeSet: this.parser.nodeSet,
      topID: this.topTerm,
      maxBufferLength: this.parser.bufferLength,
      reused: this.reused,
      start: this.ranges[0].from,
      length: t.pos - this.ranges[0].from,
      minRepeatType: this.parser.minRepeatTerm
    });
  }
  stackID(t) {
    let e = (Rt || (Rt = /* @__PURE__ */ new WeakMap())).get(t);
    return e || Rt.set(t, e = String.fromCodePoint(this.nextStackID++)), e + t;
  }
}
function oe(o, t) {
  for (let e = 0; e < t.length; e++) {
    let s = t[e];
    if (s.pos == o.pos && s.sameState(o)) {
      t[e].score < o.score && (t[e] = o);
      return;
    }
  }
  t.push(o);
}
class Le {
  constructor(t, e, s) {
    this.source = t, this.flags = e, this.disabled = s;
  }
  allows(t) {
    return !this.disabled || this.disabled[t] == 0;
  }
}
class wt extends me {
  /**
  @internal
  */
  constructor(t) {
    if (super(), this.wrappers = [], t.version != 14)
      throw new RangeError(`Parser version (${t.version}) doesn't match runtime version (14)`);
    let e = t.nodeNames.split(" ");
    this.minRepeatTerm = e.length;
    for (let n = 0; n < t.repeatNodeCount; n++)
      e.push("");
    let s = Object.keys(t.topRules).map((n) => t.topRules[n][1]), $ = [];
    for (let n = 0; n < e.length; n++)
      $.push([]);
    function r(n, h, l) {
      $[n].push([h, h.deserialize(String(l))]);
    }
    if (t.nodeProps)
      for (let n of t.nodeProps) {
        let h = n[0];
        typeof h == "string" && (h = x[h]);
        for (let l = 1; l < n.length; ) {
          let f = n[l++];
          if (f >= 0)
            r(f, h, n[l++]);
          else {
            let a = n[l + -f];
            for (let p = -f; p > 0; p--)
              r(n[l++], h, a);
            l++;
          }
        }
      }
    this.nodeSet = new At(e.map((n, h) => P.define({
      name: h >= this.minRepeatTerm ? void 0 : n,
      id: h,
      props: $[h],
      top: s.indexOf(h) > -1,
      error: h == 0,
      skipped: t.skippedNodes && t.skippedNodes.indexOf(h) > -1
    }))), t.propSources && (this.nodeSet = this.nodeSet.extend(...t.propSources)), this.strict = !1, this.bufferLength = be;
    let i = ct(t.tokenData);
    this.context = t.context, this.specializerSpecs = t.specialized || [], this.specialized = new Uint16Array(this.specializerSpecs.length);
    for (let n = 0; n < this.specializerSpecs.length; n++)
      this.specialized[n] = this.specializerSpecs[n].term;
    this.specializers = this.specializerSpecs.map(he), this.states = ct(t.states, Uint32Array), this.data = ct(t.stateData), this.goto = ct(t.goto), this.maxTerm = t.maxTerm, this.tokenizers = t.tokenizers.map((n) => typeof n == "number" ? new rt(i, n) : n), this.topRules = t.topRules, this.dialects = t.dialects || {}, this.dynamicPrecedences = t.dynamicPrecedences || null, this.tokenPrecTable = t.tokenPrec, this.termNames = t.termNames || null, this.maxNode = this.nodeSet.types.length - 1, this.dialect = this.parseDialect(), this.top = this.topRules[Object.keys(this.topRules)[0]];
  }
  createParse(t, e, s) {
    let $ = new je(this, t, e, s);
    for (let r of this.wrappers)
      $ = r($, t, e, s);
    return $;
  }
  /**
  Get a goto table entry @internal
  */
  getGoto(t, e, s = !1) {
    let $ = this.goto;
    if (e >= $[0])
      return -1;
    for (let r = $[e + 1]; ; ) {
      let i = $[r++], n = i & 1, h = $[r++];
      if (n && s)
        return h;
      for (let l = r + (i >> 1); r < l; r++)
        if ($[r] == t)
          return h;
      if (n)
        return -1;
    }
  }
  /**
  Check if this state has an action for a given terminal @internal
  */
  hasAction(t, e) {
    let s = this.data;
    for (let $ = 0; $ < 2; $++)
      for (let r = this.stateSlot(
        t,
        $ ? 2 : 1
        /* ParseState.Actions */
      ), i; ; r += 3) {
        if ((i = s[r]) == 65535)
          if (s[r + 1] == 1)
            i = s[r = A(s, r + 2)];
          else {
            if (s[r + 1] == 2)
              return A(s, r + 2);
            break;
          }
        if (i == e || i == 0)
          return A(s, r + 1);
      }
    return 0;
  }
  /**
  @internal
  */
  stateSlot(t, e) {
    return this.states[t * 6 + e];
  }
  /**
  @internal
  */
  stateFlag(t, e) {
    return (this.stateSlot(
      t,
      0
      /* ParseState.Flags */
    ) & e) > 0;
  }
  /**
  @internal
  */
  validAction(t, e) {
    return !!this.allActions(t, (s) => s == e ? !0 : null);
  }
  /**
  @internal
  */
  allActions(t, e) {
    let s = this.stateSlot(
      t,
      4
      /* ParseState.DefaultReduce */
    ), $ = s ? e(s) : void 0;
    for (let r = this.stateSlot(
      t,
      1
      /* ParseState.Actions */
    ); $ == null; r += 3) {
      if (this.data[r] == 65535)
        if (this.data[r + 1] == 1)
          r = A(this.data, r + 2);
        else
          break;
      $ = e(A(this.data, r + 1));
    }
    return $;
  }
  /**
  Get the states that can follow this one through shift actions or
  goto jumps. @internal
  */
  nextStates(t) {
    let e = [];
    for (let s = this.stateSlot(
      t,
      1
      /* ParseState.Actions */
    ); ; s += 3) {
      if (this.data[s] == 65535)
        if (this.data[s + 1] == 1)
          s = A(this.data, s + 2);
        else
          break;
      if (!(this.data[s + 2] & 1)) {
        let $ = this.data[s + 1];
        e.some((r, i) => i & 1 && r == $) || e.push(this.data[s], $);
      }
    }
    return e;
  }
  /**
  Configure the parser. Returns a new parser instance that has the
  given settings modified. Settings not provided in `config` are
  kept from the original parser.
  */
  configure(t) {
    let e = Object.assign(Object.create(wt.prototype), this);
    if (t.props && (e.nodeSet = this.nodeSet.extend(...t.props)), t.top) {
      let s = this.topRules[t.top];
      if (!s)
        throw new RangeError(`Invalid top rule name ${t.top}`);
      e.top = s;
    }
    return t.tokenizers && (e.tokenizers = this.tokenizers.map((s) => {
      let $ = t.tokenizers.find((r) => r.from == s);
      return $ ? $.to : s;
    })), t.specializers && (e.specializers = this.specializers.slice(), e.specializerSpecs = this.specializerSpecs.map((s, $) => {
      let r = t.specializers.find((n) => n.from == s.external);
      if (!r)
        return s;
      let i = Object.assign(Object.assign({}, s), { external: r.to });
      return e.specializers[$] = he(i), i;
    })), t.contextTracker && (e.context = t.contextTracker), t.dialect && (e.dialect = this.parseDialect(t.dialect)), t.strict != null && (e.strict = t.strict), t.wrap && (e.wrappers = e.wrappers.concat(t.wrap)), t.bufferLength != null && (e.bufferLength = t.bufferLength), e;
  }
  /**
  Tells you whether any [parse wrappers](#lr.ParserConfig.wrap)
  are registered for this parser.
  */
  hasWrappers() {
    return this.wrappers.length > 0;
  }
  /**
  Returns the name associated with a given term. This will only
  work for all terms when the parser was generated with the
  `--names` option. By default, only the names of tagged terms are
  stored.
  */
  getName(t) {
    return this.termNames ? this.termNames[t] : String(t <= this.maxNode && this.nodeSet.types[t].name || t);
  }
  /**
  The eof term id is always allocated directly after the node
  types. @internal
  */
  get eofTerm() {
    return this.maxNode + 1;
  }
  /**
  The type of top node produced by the parser.
  */
  get topNode() {
    return this.nodeSet.types[this.top[1]];
  }
  /**
  @internal
  */
  dynamicPrecedence(t) {
    let e = this.dynamicPrecedences;
    return e == null ? 0 : e[t] || 0;
  }
  /**
  @internal
  */
  parseDialect(t) {
    let e = Object.keys(this.dialects), s = e.map(() => !1);
    if (t)
      for (let r of t.split(" ")) {
        let i = e.indexOf(r);
        i >= 0 && (s[i] = !0);
      }
    let $ = null;
    for (let r = 0; r < e.length; r++)
      if (!s[r])
        for (let i = this.dialects[e[r]], n; (n = this.data[i++]) != 65535; )
          ($ || ($ = new Uint8Array(this.maxTerm + 1)))[n] = 1;
    return new Le(t, s, $);
  }
  /**
  Used by the output of the parser generator. Not available to
  user code. @hide
  */
  static deserialize(t) {
    return new wt(t);
  }
}
function A(o, t) {
  return o[t] | o[t + 1] << 16;
}
function Me(o) {
  let t = null;
  for (let e of o) {
    let s = e.p.stoppedAt;
    (e.pos == e.p.stream.end || s != null && e.pos > s) && e.p.parser.stateFlag(
      e.state,
      2
      /* StateFlag.Accepting */
    ) && (!t || t.score < e.score) && (t = e);
  }
  return t;
}
function he(o) {
  if (o.external) {
    let t = o.extend ? 1 : 0;
    return (e, s) => o.external(e, s) << 1 | t;
  }
  return o.get;
}
const Qt = wt.deserialize({
  version: 14,
  states: "0tQQOPOOOOOO'#C^'#C^OOOO'#C`'#C`OOOO'#Cm'#CmO`OQO'#CoOOOO'#Cn'#CnOhOSO'#C_OpOPO'#CzQOOOOOOOOO'#Cq'#CqO!ROSO,59ZOcOQO,59_OOOO'#Cc'#CcO!ZOSO'#CbOkOSO'#CbO!fOQO,58yOOOO,59f,59fOOOO1G.u1G.uO!kOQO1G.uO!pOSO1G.yO!xOWO,58|O#TOQO,58|O#]OSO,58|OOOO'#Cv'#CvOOOO1G.e1G.eOOOO7+$a7+$aOOOO7+$e7+$eO#hOQO7+$eOOOO'#Cd'#CdO#mOSO1G.hO!{OWO1G.hOOOO'#Cg'#CgO#xOSO1G.lO$QOWO1G.hO$]OQO1G.hOOOO<<HP<<HPO$eO`O7+$SO$mOQO7+$SO$uOSO7+$SO%QOSO7+$WO%YOpO7+$WO%TOQO7+$WO!{OWO7+$SO%eOWO7+$SOOOO'#Ce'#CeOOOO'#Cw'#CwO$hO`O'#CwO%pO`O<<GnO$eO`O<<GnO%{OQO<<GnO&TOpO<<GrO&`OQO<<GrOOOO'#Ch'#ChOOOO'#Cj'#CjO&eOSO'#CiOOOO'#Cx'#CxO%]OpO<<GrO&mOpO<<GrO&xOpO<<GrO'QOSO<<GnO']OSO<<GrO!{OWO<<GnOOOO,59c,59cO'eO`OAN=YOOOO-E6u-E6uO'mO`OAN=YO$eO`OAN=YO%]OpOAN=^O'xOpOAN=^O&xOpOAN=^O(TOpOAN=^O(`O!bO,59TO(qOPO,59TOOOO,59d,59dO'{OpOAN=^OOOO-E6v-E6vO%`OpO'#CxO(vOQOAN=YO)OOQOAN=^O)TOSOAN=YO)`OSOAN=^O)hO`OG22tO)pO`OG22tO&xOpOG22xO){OpOG22xO*TOpOG22xO%]OpOG22xOOOO'#Cl'#ClO*`O!bO'#DUOOOO'#Ck'#CkO*qOQO1G.oO(`O!bO1G.oO$eO`OG22tO*vOpOG22xO+ROQOG22tO+ZOQOG22xO+`O`OLD(`O+hOpOLD(dO+kOpOLD(dO&xOpOLD(dOOOO,59p,59pOOOO7+$Z7+$ZO+sOQO7+$ZO+xO`OLD(`O%]OpOLD(dO$eO`OLD(`O,TOpOLD(dO,`OpO!$'LOO,hOpO!$'LOOOOO<<Gu<<GuO,sO`O!$'KzO&xOpO!$'LOO,{O`O!$'KzO%]OpO!$'LOO-WOpO!)9AjO-`OpO!)9AjO-kO`O!)9AfO&xOpO!)9AjO-sOpO!.K7UO-{OpO!.K7UO.WOpO!4/,p",
  stateData: ".c~OTQOdSOoPOzRO~OhZO{XO~Op^Oq[O~OTQOdSOoPOzROmnX~OfaOpbO~OpeOrdOiUX~OigO~OfiO~OfjOpkO~OpnOslOuoO~OrqOiUa~OprOrqOiUa~OfsO~OpuOrtOiUi~OpyOrxO~OpzOslOuoO~Or{OiUi~Op!OOt|O~Or!QOiUq~Op!ROr!QOiUq~Op!TOr!SO~Op!YOv!UOw!VO~Op!_OslOuoO~Op!aOt|OiUy~Or!dOiUy~Op!eOv!UOw!VO~Or!hO~OT!iOp!jO~Op!lOw!VOiYy~Op!nOw!VO~Op!oOr!dOiUy~Op!pOr!hO~Ot|OiU!R~Op!sOt|OiU!R~Op!vOw!VOiY!R~Op!xOv!UOw!VO~OTQOdSOy!yOzROi_P~OT!}O~Or#OOiU!R~Or#PO~Op#QOr#OOiU!R~Op#ROr#PO~Ot|OiU!Z~Op#SOt|OiU!Z~Ow!VOiY!Z~Op#UOw!VOiY!Z~OTQOdSOy!yOzROixX~Oi#XO~Op#[Ov!UOw!VO~Or#]OiU!Z~Or#^O~Ot|OiU!c~Op#_Ow!VOiY!c~Oi#aO~Op#bOt|OiU!c~Op#eOv!UOw!VO~Ow!VOiY!k~Op#fOw!VOiY!k~Ot|OiU!k~Op#hOt|OiU!k~Ow!VOiY!s~Op#jOw!VOiY!s~Ot|OiU!s~Ow!VOiY!{~Op#lOw!VOiY!{~Ow!VOiY#T~Ovw~",
  goto: "'hyPPz!O!XP!`!c!i!w!`#]#k$R$v%i!S!O!O%oP%vP%oPP%|&P&gP'ZPPPPPPPPP'aTVOVSVOVV!z!i!z!}ZUOV!i!z!}R_UQ]URf^QmdSvnqS!]z{R!q!_d}t!P!Q!c!d!t#O#Z#]#d]!`!O!a!s#S#b#hQpdSwnqS!^z{R!r!_Q![xS!g!S!YS!u!e!hS#V!x#PS#c#[#^R#i#et!Xx!S!Z![!f!g!h!u!w#P#T#V#^#`#c#g#i#kk!k!Y!e!l!n!v!x#U#[#_#e#f#j#l!a!Wx!S!Y!Z![!e!f!g!h!l!n!u!v!w!x#P#T#U#V#[#^#_#`#c#e#f#g#i#j#k#lQ!|!iR#Y!}ZTOV!i!z!}QYSRcZRh_Q!PtY!b!P!c!t#Z#dQ!c!QQ!t!dQ#Z#OR#d#]Q!ZxS!f!S![^!m!Z!f!w#T#`#g#kS!w!g!hS#T!u#PS#`#V#^Q#g#cR#k#iQWOR`VS!{!i!}R#W!z",
  nodeNames: "⚠ Program TextRoot Expression ExpressionOpen { FormatExpression Param FormatFunction FormatStyle SelectExpression SelectFunction Offset SelectVariant VariantDescriptor VariantContent Text PluralPlaceholder HtmlTag HtmlTagOpen < TagName > HtmlTagClose / } ExpressionClose",
  maxTerm: 43,
  skippedNodes: [0],
  repeatNodeCount: 2,
  tokenData: "'8v#sR#aOX(WX^DR^p(WpqDRqs;_stFYtw;_wx?Px|;_|}G`}!OHX!O!PHX!P!Q!!R!Q![!$k![!^;_!^!_!+d!_!`;_!`!a!,j!a!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#W!$k#W#X!/S#X#b!$k#b#c!J_#c#d#>j#d#e$Ak#e#g!$k#g#h%<h#h#i'%Q#i#o!$k#o#p'2r#p#q;_#q#r'3x#r#s;_#s#y(W#y#zDR#z$f(W$f$gDR$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZ'4i#BZ$IS!$k$IS$I_DR$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JODR$JO$JT(W$JT$JUDR$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KWDR$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FVDR&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#i(e!vt`qSy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!Q;_!Q![(W![!^;_!^!_=u!_!c;_!c!}(W!}#R;_#R#S(W#S#T;_#T#o(W#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%R(W%R%S;_%S%V(W%V%W;_%W%o(W%o%p;_%p&a(W&a&b;_&b#BY(W#BY#BZ-{#BZ$IS(W$IS$I_-{$I_$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg(W$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW%#t(W%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O(W&;O&=t;_&=t&FU(W&FU&FV-{&FV&FY;_&FY&F^(W&F^&Fw;_&Fw&GW(W&GW&GX;_&GX;'S(W;'S;=`C{<%l?>`(W?>`?>b;_?>b?DR(W?DR?DT;_?DTO(W!c.SYy!boPOs-{tw-{wx.rx!^-{!_#o-{#p#q-{#q#r0d#r;'S-{;'S;=`;R<%lO-{!c.u_Os-{st/ttw-{wx/tx!^-{!^!_/t!_#o-{#o#p/t#p#q-{#q#r2s#r;'S-{;'S;=`;R<%l~-{~O-{~~0d!c/wVOw/twx-{x;'S/t;'S;=`0^<%l~/t~O/t~~0d!c0aP;=`<%l/tP0iWoPOs0dtw0dwx1Rx!^0d!_#o0d#p;'S0d;'S;=`2m<%lO0dP1U]Os0dst1}tw0dwx1}x!^0d!^!_1}!_#o0d#o#p1}#p;'S0d;'S;=`2m<%l~0d~O0d~~0dP2QVOw1}wx0dx;'S1};'S;=`2g<%l~1}~O1}~~0dP2jP;=`<%l1}P2pP;=`<%l0d!c2xZoPOs2sst3ktw2swx5wx!^2s!^!_3k!_#o2s#o#p3k#p;'S2s;'S;=`:{<%lO2s!b3nTOw3kwx3}x;'S3k;'S;=`5q<%lO3k!b4SXy!bOs3}tw3}wx4ox!^3}!_#o3}#p#q3}#r;'S3};'S;=`5k<%lO3}!b4r]Os3}st3ktw3}wx3kx!^3}!^!_3k!_#o3}#o#p3k#p#q3}#q#r3k#r;'S3};'S;=`5k<%lO3}!b5nP;=`<%l3}!b5tP;=`<%l3k!c5|_y!bOs-{st1}tw-{wx6{x!^-{!^!_1}!_#o-{#o#p1}#p#q-{#q#r0d#r;'S-{;'S;=`;R<%l~-{~O-{~~0d!c7O_Os7}st/ttw7}wx2sx!^7}!^!_/t!_#o7}#o#p/t#p#q7}#q#r/t#r;'S7};'S;=`;X<%l~7}~O7}~~0d!c8S_y!bOs7}st1}tw7}wx9Rx!^7}!^!_1}!_#o7}#o#p1}#p#q7}#q#r1}#r;'S7};'S;=`;X<%l~7}~O7}~~0d!c9W]oPOs-{st3ktw-{wx:Px!^-{!^!_3k!_#o-{#o#p3k#p#q-{#q#r2s#r;'S-{;'S;=`;R<%lO-{!c:S]Os2sst/ttw2swx7}x!^2s!^!_/t!_#o2s#o#p/t#p;'S2s;'S;=`:{<%l~2s~O2s~~0d!c;OP;=`<%l2s!c;UP;=`<%l-{!c;[P;=`<%l7}!s;hst`y!boPOX;_X^-{^p;_pq-{qs;_st=utw;_wx?Px|;_|}-{}!^;_!^!_=u!_#o;_#o#p=u#p#q;_#q#r0d#r#y;_#y#z-{#z$f;_$f$g-{$g#BY;_#BY#BZ-{#BZ$IS;_$IS$I_-{$I_$I|;_$I|$JO-{$JO$JT;_$JT$JU-{$JU$KV;_$KV$KW-{$KW&FU;_&FU&FV-{&FV;'S;_;'S;=`Cu<%lO;_`=z_t`OX=u^p=uq|=u}#q=u#r#y=u#z$f=u$g#BY=u#BZ$IS=u$I_$I|=u$JO$JT=u$JU$KV=u$KW&FU=u&FV;'S=u;'S;=`>y<%lO=u`>|P;=`<%l=u!s?Uut`OX;_X^-{^p;_pq-{qs;_stAitw;_wxAix|;_|}-{}!^;_!^!_Ai!_#o;_#o#pAi#p#q;_#q#r2s#r#y;_#y#z-{#z$f;_$f$g-{$g#BY;_#BY#BZ-{#BZ$IS;_$IS$I_-{$I_$I|;_$I|$JO-{$JO$JT;_$JT$JU-{$JU$KV;_$KV$KW-{$KW&FU;_&FU&FV-{&FV;'S;_;'S;=`Cu<%l~;_~O;_~~0d!sAnot`OXAiX^/t^pAipq/tqwAiwx;_x|Ai|}/t}#qAi#q#r/t#r#yAi#y#z/t#z$fAi$f$g/t$g#BYAi#BY#BZ/t#BZ$ISAi$IS$I_/t$I_$I|Ai$I|$JO/t$JO$JTAi$JT$JU/t$JU$KVAi$KV$KW/t$KW&FUAi&FU&FV/t&FV;'SAi;'S;=`Co<%l~Ai~OAi~~0d!sCrP;=`<%lAi!sCxP;=`<%l;_#iDOP;=`<%l(W#qD[np!^y!boPOX-{X^DR^p-{pqDRqs-{tw-{wx.rx!^-{!_#o-{#p#q-{#q#r0d#r#y-{#y#zDR#z$f-{$f$gDR$g#BY-{#BY#BZDR#BZ$IS-{$IS$I_DR$I_$I|-{$I|$JODR$JO$JT-{$JT$JUDR$JU$KV-{$KV$KWDR$KW&FU-{&FU&FVDR&FV;'S-{;'S;=`;R<%lO-{!sFa_t`z!cOX=u^p=uq|=u}#q=u#r#y=u#z$f=u$g#BY=u#BZ$IS=u$I_$I|=u$JO$JT=u$JU$KV=u$KW&FU=u&FV;'S=u;'S;=`>y<%lO=u!iGiYrUy!boPOs-{tw-{wx.rx!^-{!_#o-{#p#q-{#q#r0d#r;'S-{;'S;=`;R<%lO-{!uHd!dt`{Qy!boPOX;_X^-{^p;_pq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![HX![!^;_!^!_=u!_!c;_!c!}HX!}#R;_#R#SHX#S#T;_#T#oHX#o#p=u#p#q;_#q#r0d#r#y;_#y#z-{#z$f;_$f$g-{$g$};_$}%OHX%O%W;_%W%oHX%o%p;_%p&aHX&a&b;_&b4dHX4d4e;_4e#BYHX#BY#BZLr#BZ$ISHX$IS$I_-{$I_$I`;_$I`$IbHX$Ib$I|;_$I|$JO-{$JO$JT;_$JT$JU-{$JU$Je;_$Je$JgHX$Jg$KV;_$KV$KW-{$KW$Kh;_$Kh%#tHX%#t&/x;_&/x&EtHX&Et&FU;_&FU&FV-{&FV;'SHX;'S;:j! {;:j;=`Cu<%l?&r;_?&r?AhHX?Ah?BY;_?BY?MnHX?MnO;_!eL{|{Qy!boPOs-{tw-{wx.rx}-{}!OLr!O!PLr!P!Q-{!Q![Lr![!^-{!_!c-{!c!}Lr!}#R-{#R#SLr#S#T-{#T#oLr#p#q-{#q#r0d#r$}-{$}%OLr%O%W-{%W%oLr%o%p-{%p&aLr&a&b-{&b4dLr4d4e-{4e$ISLr$IS$I`-{$I`$IbLr$Ib$Je-{$Je$JgLr$Jg$Kh-{$Kh%#tLr%#t&/x-{&/x&EtLr&Et&FV-{&FV;'SLr;'S;:j! u;:j;=`;R<%l?&r-{?&r?AhLr?Ah?BY-{?BY?MnLr?MnO-{!e! xP;=`<%lLr!u!!OP;=`<%lHX!u!!^shQt`y!boPOX;_X^-{^p;_pq-{qs;_st=utw;_wx?Px|;_|}-{}!^;_!^!_=u!_#o;_#o#p=u#p#q;_#q#r0d#r#y;_#y#z-{#z$f;_$f$g-{$g#BY;_#BY#BZ-{#BZ$IS;_$IS$I_-{$I_$I|;_$I|$JO-{$JO$JT;_$JT$JU-{$JU$KV;_$KV$KW-{$KW&FU;_&FU&FV-{&FV;'S;_;'S;=`Cu<%lO;_#k!$z#Ut`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#k!+aP;=`<%l!$k!s!+k_d!ct`OX=u^p=uq|=u}#q=u#r#y=u#z$f=u$g#BY=u#BZ$IS=u$I_$I|=u$JO$JT=u$JU$KV=u$KW&FU=u&FV;'S=u;'S;=`>y<%lO=u!y!,usfUt`y!boPOX;_X^-{^p;_pq-{qs;_st=utw;_wx?Px|;_|}-{}!^;_!^!_=u!_#o;_#o#p=u#p#q;_#q#r0d#r#y;_#y#z-{#z$f;_$f$g-{$g#BY;_#BY#BZ-{#BZ$IS;_$IS$I_-{$I_$I|;_$I|$JO-{$JO$JT;_$JT$JU-{$JU$KV;_$KV$KW-{$KW&FU;_&FU&FV-{&FV;'S;_;'S;=`Cu<%lO;_#s!/c#Vt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#U!5x#U#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s!6X#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#h!$k#h#i!<q#i#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s!=Q#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#X!$k#X#Y!Cj#Y#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s!C{#UsWt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s!Jn#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#i!$k#i#j##W#j#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s##g#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#a!$k#a#b#*P#b#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s#*`#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#U!$k#U#V#0x#V#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s#1X#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#X!$k#X#Y#7q#Y#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s#8Q#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#f!$k#f#g!Cj#g#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#k#>y#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#Y!$k#Y#Z#Ec#Z#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#k#Er#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#Y!$k#Y#Z#L[#Z#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#k#Lk#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#g!$k#g#h$%T#h#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#k$%d#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#X!$k#X#Y$+|#Y#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#k$,]#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#h!$k#h#i$2u#i#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#k$3U#Vt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!]$9k!]!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#e$9twt`y!boPOX;_X^-{^p;_pq-{qs;_st=utw;_wx?Px{;_{|$<_|}-{}!O$<_!O!Q;_!Q![$>{![!^;_!^!_=u!_#o;_#o#p=u#p#q;_#q#r0d#r#y;_#y#z-{#z$f;_$f$g-{$g#BY;_#BY#BZ-{#BZ$IS;_$IS$I_-{$I_$I|;_$I|$JO-{$JO$JT;_$JT$JU-{$JU$KV;_$KV$KW-{$KW&FU;_&FU&FV-{&FV;'S;_;'S;=`Cu<%lO;_#e$<hut`y!boPOX;_X^-{^p;_pq-{qs;_st=utw;_wx?Px|;_|}-{}!Q;_!Q![$>{![!^;_!^!_=u!_#o;_#o#p=u#p#q;_#q#r0d#r#y;_#y#z-{#z$f;_$f$g-{$g#BY;_#BY#BZ-{#BZ$IS;_$IS$I_-{$I_$I|;_$I|$JO-{$JO$JT;_$JT$JU-{$JU$KV;_$KV$KW-{$KW&FU;_&FU&FV-{&FV;'S;_;'S;=`Cu<%lO;_#e$?Wut`y!boPvpOX;_X^-{^p;_pq-{qs;_st=utw;_wx?Px|;_|}-{}!Q;_!Q![$>{![!^;_!^!_=u!_#o;_#o#p=u#p#q;_#q#r0d#r#y;_#y#z-{#z$f;_$f$g-{$g#BY;_#BY#BZ-{#BZ$IS;_$IS$I_-{$I_$I|;_$I|$JO-{$JO$JT;_$JT$JU-{$JU$KV;_$KV$KW-{$KW&FU;_&FU&FV-{&FV;'S;_;'S;=`Cu<%lO;_#s$Az#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#`!$k#`#a$Hd#a#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s$Hs#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#i!$k#i#j% ]#j#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s% l#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#f!$k#f#g%(U#g#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s%(e#Vt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#U%.z#U#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s%/Z#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#`!$k#`#a%5s#a#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s%6U#Ut`qSuW{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s%<w#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#X!$k#X#Y%Ca#Y#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s%Cp#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#`!$k#`#a%JY#a#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s%Ji#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#X!$k#X#Y&#R#Y#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s&#b#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#V!$k#V#W&)z#W#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s&*Z#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#h!$k#h#i&0s#i#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s&1U#Wt`qSuW{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#c!$k#c#d&7n#d#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s&7}#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#f!$k#f#g&>g#g#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s&>v#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#W!$k#W#X&E`#X#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s&Eo#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#]!$k#]#^&LX#^#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s&Lh#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#b!$k#b#c%(U#c#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s'%a#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#]!$k#]#^'+y#^#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W#s',Y#Wt`qS{Qy!boPwpOX(WX^-{^p(Wpq-{qs;_st=utw;_wx?Px|;_|}-{}!OHX!O!PHX!P!Q;_!Q![!$k![!^;_!^!_=u!_!c;_!c!}!$k!}#R;_#R#S!$k#S#T;_#T#a!$k#a#b!<q#b#o!$k#o#p=u#p#q;_#q#r0d#r#s;_#s#y(W#y#z-{#z$f(W$f$g-{$g$n;_$n$o(W$o$p;_$p$q(W$q$s;_$s$t(W$t$u;_$u$v(W$v$x;_$x$|(W$|$};_$}%O!$k%O%R(W%R%S;_%S%V(W%V%W;_%W%o!$k%o%p;_%p&a!$k&a&b;_&b4d!$k4d4e(W4e#BY!$k#BY#BZLr#BZ$IS!$k$IS$I_-{$I_$I`(W$I`$Ib!$k$Ib$Id(W$Id$I|;_$I|$JO-{$JO$JT(W$JT$JU-{$JU$Je;_$Je$Jg!$k$Jg$Jz;_$Jz$J{(W$J{$KV;_$KV$KW-{$KW$Kh(W$Kh%#t!$k%#t%3d;_%3d%6z(W%6z%Dl;_%Dl%E[(W%E[&/x;_&/x&;O!$k&;O&=tHX&=t&Et!$k&Et&FU(W&FU&FV-{&FV&FYHX&FY&F^!$k&F^&FwHX&Fw&GW!$k&GW&GXHX&GX;'S!$k;'S;:j!+^;:j;=`C{<%l?&r(W?&r?>`!$k?>`?>bHX?>b?Ah!$k?Ah?BY(W?BY?DR!$k?DR?DTHX?DT?Mn!$k?MnO(W!w'2y_T!gt`OX=u^p=uq|=u}#q=u#r#y=u#z$f=u$g#BY=u#BZ$IS=u$I_$I|=u$JO$JT=u$JU$KV=u$KW&FU=u&FV;'S=u;'S;=`>y<%lO=u#k'4PWi#joPOs0dtw0dwx1Rx!^0d!_#o0d#p;'S0d;'S;=`2m<%lO0d#s'4t!`p!^{Qy!boPOX-{X^DR^p-{pqDRqs-{tw-{wx.rx}-{}!OLr!O!PLr!P!Q-{!Q![Lr![!^-{!_!c-{!c!}Lr!}#R-{#R#SLr#S#T-{#T#oLr#p#q-{#q#r0d#r#y-{#y#zDR#z$f-{$f$gDR$g$}-{$}%OLr%O%W-{%W%oLr%o%p-{%p&aLr&a&b-{&b4dLr4d4e-{4e#BYLr#BY#BZ'4i#BZ$ISLr$IS$I_DR$I_$I`-{$I`$IbLr$Ib$I|-{$I|$JODR$JO$JT-{$JT$JUDR$JU$Je-{$Je$JgLr$Jg$KV-{$KV$KWDR$KW$Kh-{$Kh%#tLr%#t&/x-{&/x&EtLr&Et&FU-{&FU&FVDR&FV;'SLr;'S;:j! u;:j;=`;R<%l?&r-{?&r?AhLr?Ah?BY-{?BY?MnLr?MnO-{",
  tokenizers: [0, 1, 2, 3, 4, 5, 6],
  topRules: { Program: [0, 1] },
  tokenPrec: 614
}), Nt = 3, Zt = 7, ts = 10, Xe = 11, Fe = 13, es = 15, ss = 17, $s = 19, rs = 21, is = 23, ns = (o) => {
  let t;
  try {
    t = Qt.configure({ strict: !0 }).parse(o);
  } catch {
    return null;
  }
  let e = t.cursor(), s;
  const $ = [], r = /* @__PURE__ */ new Map();
  function i() {
    const n = {
      name: s.name,
      type: s.type,
      position: s.position
    };
    if (n.type === "tagOpen") {
      const h = r.get(n.name) ?? [];
      h.push(n), r.set(n.name, h);
    } else if (n.type === "tagClose") {
      const h = r.get(n.name);
      h ? (h.pop(), h.length === 0 && r.delete(n.name)) : n.error = "missing_open_tag";
    }
    $.push(n), e = s.rootNode.lastChild.cursor(), s = void 0;
  }
  do {
    const n = e.node, h = o.substring(e.from, e.to);
    switch (n.type.id) {
      case ss:
        s || $.push({
          name: "#",
          type: "hash",
          position: { start: e.from, end: e.to }
        });
        break;
      case Nt:
        s || (s = {
          type: "variable",
          position: { start: e.from, end: e.to },
          rootNode: n
        });
        break;
      case ts:
        s != null && s.name || (e = s.rootNode.lastChild.cursor(), s = void 0);
        break;
      case Zt:
        (s == null ? void 0 : s.type) === "variable" && !s.name && (s.name = h, i());
        break;
      case $s:
        s || (s = {
          type: "tagOpen",
          position: { start: e.from, end: e.to },
          rootNode: n
        });
        break;
      case is:
        s || (s = {
          type: "tagClose",
          position: { start: e.from, end: e.to },
          rootNode: n
        });
        break;
      case rs:
        ((s == null ? void 0 : s.type) === "tagClose" || (s == null ? void 0 : s.type) === "tagOpen") && (s.name = h, i());
        break;
    }
  } while (e.next());
  return r.forEach(
    (n) => n.forEach((h) => {
      h.error = "missing_close_tag";
    })
  ), $;
};
class os extends qe {
  constructor(e) {
    super();
    yt(this, "value");
    this.value = e;
  }
  toDOM() {
    const e = document.createElement("span");
    let s = `placeholder-widget placeholder-${this.value.type}`;
    return this.value.error && (s = s + ` placeholder-error placeholder-error-${this.value.error}`), e.className = s, e.textContent = this.value.name || "#", e;
  }
}
function le(o, t) {
  const e = ns(o);
  return e === null ? null : e.filter((s) => {
    if (t) {
      const [$, r] = t;
      if ($ < s.position.end && r > s.position.start)
        return !1;
    }
    return !0;
  });
}
function ae(o) {
  const t = new ze();
  return o.forEach((e) => {
    t.add(
      e.position.start,
      e.position.end,
      ft.widget({
        widget: new os(e),
        side: 1
      })
    );
  }), t.finish();
}
function hs(o, t) {
  return t.find((e) => e.name === o.name && e.type === e.type);
}
function ls(o, t) {
  return t.find(
    (e) => e.name === o.name && e.type === o.type && e.position.start === e.position.start && e.position.end === e.position.end
  );
}
function as(o, t, e) {
  return t.filter((s) => !!(ls(s, o) || hs(s, e)));
}
function us(o, t, e, s, $) {
  const r = e - t, n = $ - s - r;
  return o.filter((h) => t < h.position.end && e > h.position.start ? !1 : (e < h.position.start && (h.position.start += n, h.position.end += n), !0));
}
function qt(o, t) {
  let e = o;
  return t.iterChanges((s, $, r, i) => {
    e = us(e, s, $, r, i);
  }), e;
}
const Ts = (o) => {
  const { noUpdates: t, allowedNewPlaceholders: e } = o || {};
  return xe.define({
    create(s) {
      try {
        return le(s.doc.toString(), void 0) || [];
      } catch {
        return [];
      }
    },
    update(s, $) {
      if (t)
        return qt(s, $.changes);
      if ($.docChanged && !t) {
        let r;
        $.changes.iterChanges((n, h, l, f) => {
          const a = h - n;
          f - l - a <= 1 && (r = [l, f]);
        });
        const i = le(
          $.state.doc.toString(),
          r
        );
        return i === null ? qt(s, $.changes) : e ? as(
          s,
          qt(s, $.changes),
          e
        ) : i;
      }
      return s;
    },
    provide(s) {
      return Oe.fromClass(
        class {
          constructor($) {
            yt(this, "decorationSet");
            this.decorationSet = ae($.state.field(s));
          }
          update($) {
            this.decorationSet = ae($.state.field(s));
          }
        },
        {
          decorations: ($) => $.decorationSet,
          provide: ($) => ge.atomicRanges.of((r) => {
            var i;
            return ((i = r.plugin($)) == null ? void 0 : i.decorationSet) || ft.none;
          })
        }
      );
    }
  });
};
let fs = 0;
class Y {
  /**
  @internal
  */
  constructor(t, e, s) {
    this.set = t, this.base = e, this.modified = s, this.id = fs++;
  }
  /**
  Define a new tag. If `parent` is given, the tag is treated as a
  sub-tag of that parent, and
  [highlighters](#highlight.tagHighlighter) that don't mention
  this tag will try to fall back to the parent tag (or grandparent
  tag, etc).
  */
  static define(t) {
    if (t != null && t.base)
      throw new Error("Can not derive from a modified tag");
    let e = new Y([], null, []);
    if (e.set.push(e), t)
      for (let s of t.set)
        e.set.push(s);
    return e;
  }
  /**
  Define a tag _modifier_, which is a function that, given a tag,
  will return a tag that is a subtag of the original. Applying the
  same modifier to a twice tag will return the same value (`m1(t1)
  == m1(t1)`) and applying multiple modifiers will, regardless or
  order, produce the same tag (`m1(m2(t1)) == m2(m1(t1))`).
  
  When multiple modifiers are applied to a given base tag, each
  smaller set of modifiers is registered as a parent, so that for
  example `m1(m2(m3(t1)))` is a subtype of `m1(m2(t1))`,
  `m1(m3(t1)`, and so on.
  */
  static defineModifier() {
    let t = new mt();
    return (e) => e.modified.indexOf(t) > -1 ? e : mt.get(e.base || e, e.modified.concat(t).sort((s, $) => s.id - $.id));
  }
}
let ps = 0;
class mt {
  constructor() {
    this.instances = [], this.id = ps++;
  }
  static get(t, e) {
    if (!e.length)
      return t;
    let s = e[0].instances.find((n) => n.base == t && _s(e, n.modified));
    if (s)
      return s;
    let $ = [], r = new Y($, t, e);
    for (let n of e)
      n.instances.push(r);
    let i = ds(e);
    for (let n of t.set)
      if (!n.modified.length)
        for (let h of i)
          $.push(mt.get(n, h));
    return r;
  }
}
function _s(o, t) {
  return o.length == t.length && o.every((e, s) => e == t[s]);
}
function ds(o) {
  let t = [[]];
  for (let e = 0; e < o.length; e++)
    for (let s = 0, $ = t.length; s < $; s++)
      t.push(t[s].concat(o[e]));
  return t.sort((e, s) => s.length - e.length);
}
function ye(o) {
  let t = /* @__PURE__ */ Object.create(null);
  for (let e in o) {
    let s = o[e];
    Array.isArray(s) || (s = [s]);
    for (let $ of e.split(" "))
      if ($) {
        let r = [], i = 2, n = $;
        for (let a = 0; ; ) {
          if (n == "..." && a > 0 && a + 3 == $.length) {
            i = 1;
            break;
          }
          let p = /^"(?:[^"\\]|\\.)*?"|[^\/!]+/.exec(n);
          if (!p)
            throw new RangeError("Invalid path: " + $);
          if (r.push(p[0] == "*" ? "" : p[0][0] == '"' ? JSON.parse(p[0]) : p[0]), a += p[0].length, a == $.length)
            break;
          let c = $[a++];
          if (a == $.length && c == "!") {
            i = 0;
            break;
          }
          if (c != "/")
            throw new RangeError("Invalid path: " + $);
          n = $.slice(a);
        }
        let h = r.length - 1, l = r[h];
        if (!l)
          throw new RangeError("Invalid path: " + $);
        let f = new Yt(s, i, h > 0 ? r.slice(0, h) : null);
        t[l] = f.sort(t[l]);
      }
  }
  return cs.add(t);
}
const cs = new x();
class Yt {
  constructor(t, e, s, $) {
    this.tags = t, this.mode = e, this.context = s, this.next = $;
  }
  get opaque() {
    return this.mode == 0;
  }
  get inherit() {
    return this.mode == 1;
  }
  sort(t) {
    return !t || t.depth < this.depth ? (this.next = t, this) : (t.next = this.sort(t.next), t);
  }
  get depth() {
    return this.context ? this.context.length : 0;
  }
}
Yt.empty = new Yt([], 2, null);
function ks(o, t) {
  let e = /* @__PURE__ */ Object.create(null);
  for (let r of o)
    if (!Array.isArray(r.tag))
      e[r.tag.id] = r.class;
    else
      for (let i of r.tag)
        e[i.id] = r.class;
  let { scope: s, all: $ = null } = t || {};
  return {
    style: (r) => {
      let i = $;
      for (let n of r)
        for (let h of n.set) {
          let l = e[h.id];
          if (l) {
            i = i ? i + " " + l : l;
            break;
          }
        }
      return i;
    },
    scope: s
  };
}
const u = Y.define, kt = u(), C = u(), ue = u(C), fe = u(C), E = u(), Wt = u(E), Bt = u(E), v = u(), tt = u(v), H = u(), D = u(), Kt = u(), lt = u(Kt), Ot = u(), d = {
  /**
  A comment.
  */
  comment: kt,
  /**
  A line [comment](#highlight.tags.comment).
  */
  lineComment: u(kt),
  /**
  A block [comment](#highlight.tags.comment).
  */
  blockComment: u(kt),
  /**
  A documentation [comment](#highlight.tags.comment).
  */
  docComment: u(kt),
  /**
  Any kind of identifier.
  */
  name: C,
  /**
  The [name](#highlight.tags.name) of a variable.
  */
  variableName: u(C),
  /**
  A type [name](#highlight.tags.name).
  */
  typeName: ue,
  /**
  A tag name (subtag of [`typeName`](#highlight.tags.typeName)).
  */
  tagName: u(ue),
  /**
  A property or field [name](#highlight.tags.name).
  */
  propertyName: fe,
  /**
  An attribute name (subtag of [`propertyName`](#highlight.tags.propertyName)).
  */
  attributeName: u(fe),
  /**
  The [name](#highlight.tags.name) of a class.
  */
  className: u(C),
  /**
  A label [name](#highlight.tags.name).
  */
  labelName: u(C),
  /**
  A namespace [name](#highlight.tags.name).
  */
  namespace: u(C),
  /**
  The [name](#highlight.tags.name) of a macro.
  */
  macroName: u(C),
  /**
  A literal value.
  */
  literal: E,
  /**
  A string [literal](#highlight.tags.literal).
  */
  string: Wt,
  /**
  A documentation [string](#highlight.tags.string).
  */
  docString: u(Wt),
  /**
  A character literal (subtag of [string](#highlight.tags.string)).
  */
  character: u(Wt),
  /**
  An attribute value (subtag of [string](#highlight.tags.string)).
  */
  attributeValue: u(Wt),
  /**
  A number [literal](#highlight.tags.literal).
  */
  number: Bt,
  /**
  An integer [number](#highlight.tags.number) literal.
  */
  integer: u(Bt),
  /**
  A floating-point [number](#highlight.tags.number) literal.
  */
  float: u(Bt),
  /**
  A boolean [literal](#highlight.tags.literal).
  */
  bool: u(E),
  /**
  Regular expression [literal](#highlight.tags.literal).
  */
  regexp: u(E),
  /**
  An escape [literal](#highlight.tags.literal), for example a
  backslash escape in a string.
  */
  escape: u(E),
  /**
  A color [literal](#highlight.tags.literal).
  */
  color: u(E),
  /**
  A URL [literal](#highlight.tags.literal).
  */
  url: u(E),
  /**
  A language keyword.
  */
  keyword: H,
  /**
  The [keyword](#highlight.tags.keyword) for the self or this
  object.
  */
  self: u(H),
  /**
  The [keyword](#highlight.tags.keyword) for null.
  */
  null: u(H),
  /**
  A [keyword](#highlight.tags.keyword) denoting some atomic value.
  */
  atom: u(H),
  /**
  A [keyword](#highlight.tags.keyword) that represents a unit.
  */
  unit: u(H),
  /**
  A modifier [keyword](#highlight.tags.keyword).
  */
  modifier: u(H),
  /**
  A [keyword](#highlight.tags.keyword) that acts as an operator.
  */
  operatorKeyword: u(H),
  /**
  A control-flow related [keyword](#highlight.tags.keyword).
  */
  controlKeyword: u(H),
  /**
  A [keyword](#highlight.tags.keyword) that defines something.
  */
  definitionKeyword: u(H),
  /**
  A [keyword](#highlight.tags.keyword) related to defining or
  interfacing with modules.
  */
  moduleKeyword: u(H),
  /**
  An operator.
  */
  operator: D,
  /**
  An [operator](#highlight.tags.operator) that dereferences something.
  */
  derefOperator: u(D),
  /**
  Arithmetic-related [operator](#highlight.tags.operator).
  */
  arithmeticOperator: u(D),
  /**
  Logical [operator](#highlight.tags.operator).
  */
  logicOperator: u(D),
  /**
  Bit [operator](#highlight.tags.operator).
  */
  bitwiseOperator: u(D),
  /**
  Comparison [operator](#highlight.tags.operator).
  */
  compareOperator: u(D),
  /**
  [Operator](#highlight.tags.operator) that updates its operand.
  */
  updateOperator: u(D),
  /**
  [Operator](#highlight.tags.operator) that defines something.
  */
  definitionOperator: u(D),
  /**
  Type-related [operator](#highlight.tags.operator).
  */
  typeOperator: u(D),
  /**
  Control-flow [operator](#highlight.tags.operator).
  */
  controlOperator: u(D),
  /**
  Program or markup punctuation.
  */
  punctuation: Kt,
  /**
  [Punctuation](#highlight.tags.punctuation) that separates
  things.
  */
  separator: u(Kt),
  /**
  Bracket-style [punctuation](#highlight.tags.punctuation).
  */
  bracket: lt,
  /**
  Angle [brackets](#highlight.tags.bracket) (usually `<` and `>`
  tokens).
  */
  angleBracket: u(lt),
  /**
  Square [brackets](#highlight.tags.bracket) (usually `[` and `]`
  tokens).
  */
  squareBracket: u(lt),
  /**
  Parentheses (usually `(` and `)` tokens). Subtag of
  [bracket](#highlight.tags.bracket).
  */
  paren: u(lt),
  /**
  Braces (usually `{` and `}` tokens). Subtag of
  [bracket](#highlight.tags.bracket).
  */
  brace: u(lt),
  /**
  Content, for example plain text in XML or markup documents.
  */
  content: v,
  /**
  [Content](#highlight.tags.content) that represents a heading.
  */
  heading: tt,
  /**
  A level 1 [heading](#highlight.tags.heading).
  */
  heading1: u(tt),
  /**
  A level 2 [heading](#highlight.tags.heading).
  */
  heading2: u(tt),
  /**
  A level 3 [heading](#highlight.tags.heading).
  */
  heading3: u(tt),
  /**
  A level 4 [heading](#highlight.tags.heading).
  */
  heading4: u(tt),
  /**
  A level 5 [heading](#highlight.tags.heading).
  */
  heading5: u(tt),
  /**
  A level 6 [heading](#highlight.tags.heading).
  */
  heading6: u(tt),
  /**
  A prose separator (such as a horizontal rule).
  */
  contentSeparator: u(v),
  /**
  [Content](#highlight.tags.content) that represents a list.
  */
  list: u(v),
  /**
  [Content](#highlight.tags.content) that represents a quote.
  */
  quote: u(v),
  /**
  [Content](#highlight.tags.content) that is emphasized.
  */
  emphasis: u(v),
  /**
  [Content](#highlight.tags.content) that is styled strong.
  */
  strong: u(v),
  /**
  [Content](#highlight.tags.content) that is part of a link.
  */
  link: u(v),
  /**
  [Content](#highlight.tags.content) that is styled as code or
  monospace.
  */
  monospace: u(v),
  /**
  [Content](#highlight.tags.content) that has a strike-through
  style.
  */
  strikethrough: u(v),
  /**
  Inserted text in a change-tracking format.
  */
  inserted: u(),
  /**
  Deleted text.
  */
  deleted: u(),
  /**
  Changed text.
  */
  changed: u(),
  /**
  An invalid or unsyntactic element.
  */
  invalid: u(),
  /**
  Metadata or meta-instruction.
  */
  meta: Ot,
  /**
  [Metadata](#highlight.tags.meta) that applies to the entire
  document.
  */
  documentMeta: u(Ot),
  /**
  [Metadata](#highlight.tags.meta) that annotates or adds
  attributes to a given syntactic element.
  */
  annotation: u(Ot),
  /**
  Processing instruction or preprocessor directive. Subtag of
  [meta](#highlight.tags.meta).
  */
  processingInstruction: u(Ot),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates that a
  given element is being defined. Expected to be used with the
  various [name](#highlight.tags.name) tags.
  */
  definition: Y.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates that
  something is constant. Mostly expected to be used with
  [variable names](#highlight.tags.variableName).
  */
  constant: Y.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) used to indicate that
  a [variable](#highlight.tags.variableName) or [property
  name](#highlight.tags.propertyName) is being called or defined
  as a function.
  */
  function: Y.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that can be applied to
  [names](#highlight.tags.name) to indicate that they belong to
  the language's standard environment.
  */
  standard: Y.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates a given
  [names](#highlight.tags.name) is local to some scope.
  */
  local: Y.defineModifier(),
  /**
  A generic variant [modifier](#highlight.Tag^defineModifier) that
  can be used to tag language-specific alternative variants of
  some common tag. It is recommended for themes to define special
  forms of at least the [string](#highlight.tags.string) and
  [variable name](#highlight.tags.variableName) tags, since those
  come up a lot.
  */
  special: Y.defineModifier()
};
ks([
  { tag: d.link, class: "tok-link" },
  { tag: d.heading, class: "tok-heading" },
  { tag: d.emphasis, class: "tok-emphasis" },
  { tag: d.strong, class: "tok-strong" },
  { tag: d.keyword, class: "tok-keyword" },
  { tag: d.atom, class: "tok-atom" },
  { tag: d.bool, class: "tok-bool" },
  { tag: d.url, class: "tok-url" },
  { tag: d.labelName, class: "tok-labelName" },
  { tag: d.inserted, class: "tok-inserted" },
  { tag: d.deleted, class: "tok-deleted" },
  { tag: d.literal, class: "tok-literal" },
  { tag: d.string, class: "tok-string" },
  { tag: d.number, class: "tok-number" },
  { tag: [d.regexp, d.escape, d.special(d.string)], class: "tok-string2" },
  { tag: d.variableName, class: "tok-variableName" },
  { tag: d.local(d.variableName), class: "tok-variableName tok-local" },
  { tag: d.definition(d.variableName), class: "tok-variableName tok-definition" },
  { tag: d.special(d.variableName), class: "tok-variableName2" },
  { tag: d.definition(d.propertyName), class: "tok-propertyName tok-definition" },
  { tag: d.typeName, class: "tok-typeName" },
  { tag: d.namespace, class: "tok-namespace" },
  { tag: d.className, class: "tok-className" },
  { tag: d.macroName, class: "tok-macroName" },
  { tag: d.propertyName, class: "tok-propertyName" },
  { tag: d.operator, class: "tok-operator" },
  { tag: d.comment, class: "tok-comment" },
  { tag: d.meta, class: "tok-meta" },
  { tag: d.invalid, class: "tok-invalid" },
  { tag: d.punctuation, class: "tok-punctuation" }
]);
var zt;
const ut = /* @__PURE__ */ new x();
function Ws(o) {
  return Se.define({
    combine: o ? (t) => t.concat(o) : void 0
  });
}
const Os = /* @__PURE__ */ new x();
class K {
  /**
  Construct a language object. If you need to invoke this
  directly, first define a data facet with
  [`defineLanguageFacet`](https://codemirror.net/6/docs/ref/#language.defineLanguageFacet), and then
  configure your parser to [attach](https://codemirror.net/6/docs/ref/#language.languageDataProp) it
  to the language's outer syntax node.
  */
  constructor(t, e, s = [], $ = "") {
    this.data = t, this.name = $, Tt.prototype.hasOwnProperty("tree") || Object.defineProperty(Tt.prototype, "tree", { get() {
      return Ut(this);
    } }), this.parser = e, this.extension = [
      nt.of(this),
      Tt.languageData.of((r, i, n) => {
        let h = pe(r, i, n), l = h.type.prop(ut);
        if (!l)
          return [];
        let f = r.facet(l), a = h.type.prop(Os);
        if (a) {
          let p = h.resolve(i - h.from, n);
          for (let c of a)
            if (c.test(p, r)) {
              let k = r.facet(c.facet);
              return c.type == "replace" ? k : k.concat(f);
            }
        }
        return f;
      })
    ].concat(s);
  }
  /**
  Query whether this language is active at the given position.
  */
  isActiveAt(t, e, s = -1) {
    return pe(t, e, s).type.prop(ut) == this.data;
  }
  /**
  Find the document regions that were parsed using this language.
  The returned regions will _include_ any nested languages rooted
  in this language, when those exist.
  */
  findRegions(t) {
    let e = t.facet(nt);
    if ((e == null ? void 0 : e.data) == this.data)
      return [{ from: 0, to: t.doc.length }];
    if (!e || !e.allowsNesting)
      return [];
    let s = [], $ = (r, i) => {
      if (r.prop(ut) == this.data) {
        s.push({ from: i, to: i + r.length });
        return;
      }
      let n = r.prop(x.mounted);
      if (n) {
        if (n.tree.prop(ut) == this.data) {
          if (n.overlay)
            for (let h of n.overlay)
              s.push({ from: h.from + i, to: h.to + i });
          else
            s.push({ from: i, to: i + r.length });
          return;
        } else if (n.overlay) {
          let h = s.length;
          if ($(n.tree, n.overlay[0].from + i), s.length > h)
            return;
        }
      }
      for (let h = 0; h < r.children.length; h++) {
        let l = r.children[h];
        l instanceof X && $(l, r.positions[h] + i);
      }
    };
    return $(Ut(t), 0), s;
  }
  /**
  Indicates whether this language allows nested languages. The
  default implementation returns true.
  */
  get allowsNesting() {
    return !0;
  }
}
K.setState = /* @__PURE__ */ Ve.define();
function pe(o, t, e) {
  let s = o.facet(nt), $ = Ut(o).topNode;
  if (!s || s.allowsNesting)
    for (let r = $; r; r = r.enter(t, e, F.ExcludeBuffers))
      r.type.isTop && ($ = r);
  return $;
}
class Xt extends K {
  constructor(t, e, s) {
    super(t, e, [], s), this.parser = e;
  }
  /**
  Define a language from a parser.
  */
  static define(t) {
    let e = Ws(t.languageData);
    return new Xt(e, t.parser.configure({
      props: [ut.add((s) => s.isTop ? e : void 0)]
    }), t.name);
  }
  /**
  Create a new instance of this language with a reconfigured
  version of its parser and optionally a new name.
  */
  configure(t, e) {
    return new Xt(this.data, this.parser.configure(t), e || this.name);
  }
  get allowsNesting() {
    return this.parser.hasWrappers();
  }
}
function Ut(o) {
  let t = o.field(K.state, !1);
  return t ? t.tree : X.empty;
}
class gs {
  /**
  Create an input object for the given document.
  */
  constructor(t) {
    this.doc = t, this.cursorPos = 0, this.string = "", this.cursor = t.iter();
  }
  get length() {
    return this.doc.length;
  }
  syncTo(t) {
    return this.string = this.cursor.next(t - this.cursorPos).value, this.cursorPos = t + this.string.length, this.cursorPos - this.string.length;
  }
  chunk(t) {
    return this.syncTo(t), this.string;
  }
  get lineChunks() {
    return !0;
  }
  read(t, e) {
    let s = this.cursorPos - this.string.length;
    return t < s || e >= this.cursorPos ? this.doc.sliceString(t, e) : this.string.slice(t - s, e - s);
  }
}
let at = null;
class Ft {
  constructor(t, e, s = [], $, r, i, n, h) {
    this.parser = t, this.state = e, this.fragments = s, this.tree = $, this.treeLen = r, this.viewport = i, this.skipped = n, this.scheduleOn = h, this.parse = null, this.tempSkipped = [];
  }
  /**
  @internal
  */
  static create(t, e, s) {
    return new Ft(t, e, [], X.empty, 0, s, [], null);
  }
  startParse() {
    return this.parser.startParse(new gs(this.state.doc), this.fragments);
  }
  /**
  @internal
  */
  work(t, e) {
    return e != null && e >= this.state.doc.length && (e = void 0), this.tree != X.empty && this.isDone(e ?? this.state.doc.length) ? (this.takeTree(), !0) : this.withContext(() => {
      var s;
      if (typeof t == "number") {
        let $ = Date.now() + t;
        t = () => Date.now() > $;
      }
      for (this.parse || (this.parse = this.startParse()), e != null && (this.parse.stoppedAt == null || this.parse.stoppedAt > e) && e < this.state.doc.length && this.parse.stopAt(e); ; ) {
        let $ = this.parse.advance();
        if ($)
          if (this.fragments = this.withoutTempSkipped(et.addTree($, this.fragments, this.parse.stoppedAt != null)), this.treeLen = (s = this.parse.stoppedAt) !== null && s !== void 0 ? s : this.state.doc.length, this.tree = $, this.parse = null, this.treeLen < (e ?? this.state.doc.length))
            this.parse = this.startParse();
          else
            return !0;
        if (t())
          return !1;
      }
    });
  }
  /**
  @internal
  */
  takeTree() {
    let t, e;
    this.parse && (t = this.parse.parsedPos) >= this.treeLen && ((this.parse.stoppedAt == null || this.parse.stoppedAt > t) && this.parse.stopAt(t), this.withContext(() => {
      for (; !(e = this.parse.advance()); )
        ;
    }), this.treeLen = t, this.tree = e, this.fragments = this.withoutTempSkipped(et.addTree(this.tree, this.fragments, !0)), this.parse = null);
  }
  withContext(t) {
    let e = at;
    at = this;
    try {
      return t();
    } finally {
      at = e;
    }
  }
  withoutTempSkipped(t) {
    for (let e; e = this.tempSkipped.pop(); )
      t = _e(t, e.from, e.to);
    return t;
  }
  /**
  @internal
  */
  changes(t, e) {
    let { fragments: s, tree: $, treeLen: r, viewport: i, skipped: n } = this;
    if (this.takeTree(), !t.empty) {
      let h = [];
      if (t.iterChangedRanges((l, f, a, p) => h.push({ fromA: l, toA: f, fromB: a, toB: p })), s = et.applyChanges(s, h), $ = X.empty, r = 0, i = { from: t.mapPos(i.from, -1), to: t.mapPos(i.to, 1) }, this.skipped.length) {
        n = [];
        for (let l of this.skipped) {
          let f = t.mapPos(l.from, 1), a = t.mapPos(l.to, -1);
          f < a && n.push({ from: f, to: a });
        }
      }
    }
    return new Ft(this.parser, e, s, $, r, i, n, this.scheduleOn);
  }
  /**
  @internal
  */
  updateViewport(t) {
    if (this.viewport.from == t.from && this.viewport.to == t.to)
      return !1;
    this.viewport = t;
    let e = this.skipped.length;
    for (let s = 0; s < this.skipped.length; s++) {
      let { from: $, to: r } = this.skipped[s];
      $ < t.to && r > t.from && (this.fragments = _e(this.fragments, $, r), this.skipped.splice(s--, 1));
    }
    return this.skipped.length >= e ? !1 : (this.reset(), !0);
  }
  /**
  @internal
  */
  reset() {
    this.parse && (this.takeTree(), this.parse = null);
  }
  /**
  Notify the parse scheduler that the given region was skipped
  because it wasn't in view, and the parse should be restarted
  when it comes into view.
  */
  skipUntilInView(t, e) {
    this.skipped.push({ from: t, to: e });
  }
  /**
  Returns a parser intended to be used as placeholder when
  asynchronously loading a nested parser. It'll skip its input and
  mark it as not-really-parsed, so that the next update will parse
  it again.
  
  When `until` is given, a reparse will be scheduled when that
  promise resolves.
  */
  static getSkippingParser(t) {
    return new class extends me {
      createParse(e, s, $) {
        let r = $[0].from, i = $[$.length - 1].to;
        return {
          parsedPos: r,
          advance() {
            let h = at;
            if (h) {
              for (let l of $)
                h.tempSkipped.push(l);
              t && (h.scheduleOn = h.scheduleOn ? Promise.all([h.scheduleOn, t]) : t);
            }
            return this.parsedPos = i, new X(P.none, [], [], i - r);
          },
          stoppedAt: null,
          stopAt() {
          }
        };
      }
    }();
  }
  /**
  @internal
  */
  isDone(t) {
    t = Math.min(t, this.state.doc.length);
    let e = this.fragments;
    return this.treeLen >= t && e.length && e[0].from == 0 && e[0].to >= t;
  }
  /**
  Get the context for the current parse, or `null` if no editor
  parse is in progress.
  */
  static get() {
    return at;
  }
}
function _e(o, t, e) {
  return et.applyChanges(o, [{ fromA: t, toA: e, fromB: t, toB: e }]);
}
class it {
  constructor(t) {
    this.context = t, this.tree = t.tree;
  }
  apply(t) {
    if (!t.docChanged && this.tree == this.context.tree)
      return this;
    let e = this.context.changes(t.changes, t.state), s = this.context.treeLen == t.startState.doc.length ? void 0 : Math.max(t.changes.mapPos(this.context.treeLen), e.viewport.to);
    return e.work(20, s) || e.takeTree(), new it(e);
  }
  static init(t) {
    let e = Math.min(3e3, t.doc.length), s = Ft.create(t.facet(nt).parser, t, { from: 0, to: e });
    return s.work(20, e) || s.takeTree(), new it(s);
  }
}
K.state = /* @__PURE__ */ xe.define({
  create: it.init,
  update(o, t) {
    for (let e of t.effects)
      if (e.is(K.setState))
        return e.value;
    return t.startState.facet(nt) != t.state.facet(nt) ? it.init(t.state) : o.apply(t);
  }
});
let Te = (o) => {
  let t = setTimeout(
    () => o(),
    500
    /* Work.MaxPause */
  );
  return () => clearTimeout(t);
};
typeof requestIdleCallback < "u" && (Te = (o) => {
  let t = -1, e = setTimeout(
    () => {
      t = requestIdleCallback(o, {
        timeout: 400
        /* Work.MinPause */
      });
    },
    100
    /* Work.MinPause */
  );
  return () => t < 0 ? clearTimeout(e) : cancelIdleCallback(t);
});
const Vt = typeof navigator < "u" && (!((zt = navigator.scheduling) === null || zt === void 0) && zt.isInputPending) ? () => navigator.scheduling.isInputPending() : null, xs = /* @__PURE__ */ Oe.fromClass(class {
  constructor(t) {
    this.view = t, this.working = null, this.workScheduled = 0, this.chunkEnd = -1, this.chunkBudget = -1, this.work = this.work.bind(this), this.scheduleWork();
  }
  update(t) {
    let e = this.view.state.field(K.state).context;
    (e.updateViewport(t.view.viewport) || this.view.viewport.to > e.treeLen) && this.scheduleWork(), (t.docChanged || t.selectionSet) && (this.view.hasFocus && (this.chunkBudget += 50), this.scheduleWork()), this.checkAsyncSchedule(e);
  }
  scheduleWork() {
    if (this.working)
      return;
    let { state: t } = this.view, e = t.field(K.state);
    (e.tree != e.context.tree || !e.context.isDone(t.doc.length)) && (this.working = Te(this.work));
  }
  work(t) {
    this.working = null;
    let e = Date.now();
    if (this.chunkEnd < e && (this.chunkEnd < 0 || this.view.hasFocus) && (this.chunkEnd = e + 3e4, this.chunkBudget = 3e3), this.chunkBudget <= 0)
      return;
    let { state: s, viewport: { to: $ } } = this.view, r = s.field(K.state);
    if (r.tree == r.context.tree && r.context.isDone(
      $ + 1e5
      /* Work.MaxParseAhead */
    ))
      return;
    let i = Date.now() + Math.min(this.chunkBudget, 100, t && !Vt ? Math.max(25, t.timeRemaining() - 5) : 1e9), n = r.context.treeLen < $ && s.doc.length > $ + 1e3, h = r.context.work(() => Vt && Vt() || Date.now() > i, $ + (n ? 0 : 1e5));
    this.chunkBudget -= Date.now() - e, (h || this.chunkBudget <= 0) && (r.context.takeTree(), this.view.dispatch({ effects: K.setState.of(new it(r.context)) })), this.chunkBudget > 0 && !(h && !n) && this.scheduleWork(), this.checkAsyncSchedule(r.context);
  }
  checkAsyncSchedule(t) {
    t.scheduleOn && (this.workScheduled++, t.scheduleOn.then(() => this.scheduleWork()).catch((e) => Be(this.view.state, e)).then(() => this.workScheduled--), t.scheduleOn = null);
  }
  destroy() {
    this.working && this.working();
  }
  isWorking() {
    return !!(this.working || this.workScheduled > 0);
  }
}, {
  eventHandlers: { focus() {
    this.scheduleWork();
  } }
}), nt = /* @__PURE__ */ Se.define({
  combine(o) {
    return o.length ? o[0] : null;
  },
  enables: (o) => [
    K.state,
    xs,
    ge.contentAttributes.compute([o], (t) => {
      let e = t.facet(o);
      return e && e.name ? { "data-language": e.name } : {};
    })
  ]
});
class Ss {
  /**
  Create a language support object.
  */
  constructor(t, e = []) {
    this.language = t, this.support = e, this.extension = [t, e];
  }
}
const bs = /* @__PURE__ */ Object.create(null), de = [P.none], ce = [], ke = /* @__PURE__ */ Object.create(null), Js = /* @__PURE__ */ Object.create(null);
for (let [o, t] of [
  ["variable", "variableName"],
  ["variable-2", "variableName.special"],
  ["string-2", "string.special"],
  ["def", "variableName.definition"],
  ["tag", "tagName"],
  ["attribute", "attributeName"],
  ["type", "typeName"],
  ["builtin", "variableName.standard"],
  ["qualifier", "modifier"],
  ["error", "invalid"],
  ["header", "heading"],
  ["property", "propertyName"]
])
  Js[o] = /* @__PURE__ */ Is(bs, t);
function Ht(o, t) {
  ce.indexOf(o) > -1 || (ce.push(o), console.warn(t));
}
function Is(o, t) {
  let e = [];
  for (let n of t.split(" ")) {
    let h = [];
    for (let l of n.split(".")) {
      let f = o[l] || d[l];
      f ? typeof f == "function" ? h.length ? h = h.map(f) : Ht(l, `Modifier ${l} used at start of tag`) : h.length ? Ht(l, `Tag ${l} used as modifier`) : h = Array.isArray(f) ? f : [f] : Ht(l, `Unknown highlighting tag ${l}`);
    }
    for (let l of h)
      e.push(l);
  }
  if (!e.length)
    return 0;
  let s = t.replace(/ /g, "_"), $ = s + " " + e.map((n) => n.id), r = ke[$];
  if (r)
    return r.id;
  let i = ke[$] = P.define({
    id: de.length,
    name: s,
    props: [ye({ [s]: e })]
  });
  return de.push(i), i.id;
}
Mt.RTL, Mt.LTR;
const ws = Xt.define({
  name: "icu-tolgee",
  parser: Qt.configure({
    props: [
      ye({
        Param: d.variableName,
        TextRoot: d.string,
        Text: d.string,
        VariantDescriptor: d.variableName,
        "{ }": d.paren,
        HtmlTag: d.variableName
      })
    ]
  })
});
function Rs() {
  return new Ss(ws);
}
const We = {
  0: Nt,
  4: Zt,
  5: Xe,
  // this also excludes 'offset:x'
  6: Fe
};
function St(o, t) {
  return t.substring(o.from, o.to);
}
function ms(o, t) {
  let e = o.firstChild;
  do
    if ((e == null ? void 0 : e.type.id) === es)
      return St(e, t);
  while (e = e == null ? void 0 : e.nextSibling);
  return "";
}
const qs = (o) => {
  let t;
  try {
    t = Qt.configure({ strict: !0 }).parse(o);
  } catch {
    return null;
  }
  const e = t.cursor(), s = {}, $ = /* @__PURE__ */ new Map(), r = Object.keys(We), i = Number(r[r.length - 1]);
  for (let h = 0; h <= i; h++) {
    e.next();
    const l = e.node, f = We[h];
    if (f !== void 0)
      if (f === l.type.id)
        s[l.type.id] = l;
      else
        return null;
  }
  if (s[Nt].nextSibling || St(s[Xe], o) !== "plural")
    return null;
  let n = s[Fe];
  do {
    const h = St(n.firstChild, o), l = ms(n, o);
    if ($.get(h))
      return null;
    $.set(h, l);
  } while (n = n.nextSibling);
  return {
    parameter: St(s[Zt], o),
    variants: $
  };
};
export {
  Ts as PlaceholderPlugin,
  ns as getPlaceholders,
  qs as getTolgeePlurals,
  Qt as tolgeeParser,
  Rs as tolgeeSyntax
};
